function objective_function = estimation_f(param, f_type, display, global_param, T_MAX, DRAW_B, DRAW_F, SCHOOL_GROUPS, husbands, wives, wage_moments, marr_fer_moments, emp_moments, general_moments, epsilon_b, epsilon_f, h_draws_b, w_draws_b, w_ability_draw, h_draws, w_draws) 
%estimation_f
%   T - number of periods
%   numdraws - number of random draws
%   OBS - number of observations
%   Author: Osnat Lifshitz
%   Date: 12-sept-12
%keyboard();
%debug_on_error();
% set small scale to 1 for running in small scale
small_scale = 1;


if (small_scale == 1)
    K0 = 0;
    K5 = 0;
    K10 = 0;
    K20 = 0;
    HE0 = 0;
    HE5 = 0;
    HE10 = 0;
    HE20 = 0;
    TERMINAL = 25;
    H_EXP20 = 0;
    EMAX21 = TERMINAL - 18 + 1 + 1;
else
    K0 = 0;
    K5 = 5;
    K10 = 10;
    K20 = 20;
    HE0 = 0;
    HE5 = 5;
    HE10 = 10;
    HE20 = 20;
    TERMINAL = 45;
    H_EXP20 = 20;
    EMAX21 = H_EXP20 + 1;
end
%global fitted_moments_out;
%global actual_moments_out;

x_idx = get_global_param_idx(f_type);
global_param(x_idx) = param;
sigma = zeros(5,5);
% Utility parameters WIFE:  
alpha1_w  = global_param(1);        % utility from leisure 
alpha21_w = global_param(2);        % utility from young children
alpha22_w = global_param(3);        % utility from old children
alpha31_w = global_param(4);        % utility from young children when married
alpha32_w = global_param(5);        % utility from old children when married 
% Utility parameters HUSBAND: 
%alpha1_h = global_param();         % utility from leisure 
alpha21_h = global_param(6);        % utility from young children
alpha22_h = global_param(7);        % utility from old children
% Wage parameters wife
beta1_w  = global_param(8);     %experience 
beta2_w  = global_param(9);     %exp^2  
%beta30_w = global_param();     %HSD - schooling    
beta31_w = global_param(10);    %HSG - schooling    
beta32_w = global_param(11);    %SC -  schooling    
beta33_w = global_param(12);    %CG -  schooling    
beta34_w = global_param(13);    %PC -  schooling
% Wage parameters husband
beta1_h  = global_param(14);    %experience 
beta2_h  = global_param(15);    %exp^2  
beta30_h = global_param(16);    %HSD - schooling    
beta31_h = global_param(17);    %HSG- schooling 
beta32_h = global_param(18);    %SC -  schooling    
beta33_h = global_param(19);    %CG -  schooling    
beta34_h = global_param(20);    %PC -  schooling    
% Job offer parameters  wife - husband always work, prob=1
row0   = global_param(21);      % work in previous period
row11  = global_param(22);      % HSG -schooling
row12  = global_param(23);      % SC - schooling
row13  = global_param(24);      % CG - schooling
row14  = global_param(25);      % PC - schooling
row2   = global_param(26);      % work experience
%home production technology - parameters    
hp1 = global_param(27);         % # of young children influence on work at home hours
hp2 = global_param(28);         % # of old children influence on work at home hours
%hp3 = global_param();          % husband leisure - always working so zero
hp4 = global_param(29);         % wife leisure
hp5 = global_param(30);         % # of young children influence on consumption  
hp6 = global_param(31);         % # of old children influence on consumption
hp7 = global_param(32);         % sigma CRRA parameter
hp8 = global_param(33);         % CRRA income parameter
%probability of another child parameters    
c1= global_param(34);           % previous work state - wife
c2 = global_param(35);          %age wife - HSG
c3 = global_param(36);          %age square wife - HSG
c4 = global_param(37);          %age wife - SC
c5 = global_param(38);          %age square wife - SC
c6 = global_param(39);          %age wife - CG
c7 = global_param(40);          %age square wife - CG
c8 = global_param(41);          %age wife - PC
c9 = global_param(42);          %age square wife - PC
c10 = global_param(43);         %number of children at household    
c11 = global_param(44);         % schooling - husband
c12 = global_param(45);         % married - M
% terminal value Parameters
%t0 = global_param();           % schooling wife - HSD
t1_w = global_param(46);        % schooling wife - HSG
t2_w = global_param(47);        % schooling wife - SC
t3_w = global_param(48);        % schooling wife - CG
t4_w = global_param(49);        % schooling wife - PC
t5_w = global_param(50);        % exp wife
t6_w = global_param(51);        % schooling husband if married - HSD
t7_w = global_param(52);        % schooling husband if married - HSG
t8_w = global_param(53);        % schooling husband if married - SC
t9_w = global_param(54);        % schooling husband if married - CG
t10_w = global_param(55);       % schooling husband if married - PC
t11_w = global_param(56);       % exp husband if married 
t12_w = global_param(57);       % martial status
t13_w = global_param(58);       % number of children
t14_w = global_param(59);       % match quality if married
t15_w = global_param(60);       % number of children if married
t16_w = global_param(61);       % previous work state - wife
% terminal value Parameters
%t0 = global_param();           % schooling wife if married - HSD
t1_h = global_param(62);        % schooling wife if married- HSG
t2_h = global_param(63);        % schooling wife if married- SC
t3_h = global_param(64);        % schooling wife if married- CG
t4_h = global_param(65);        % schooling wife if married- PC
t5_h = global_param(66);        % exp wife if married
t6_h = global_param(67);        % schooling husband - HSD
t7_h = global_param(68);        % schooling husband - HSG
t8_h = global_param(69);        % schooling husband - SC
t9_h = global_param(70);        % schooling husband - CG
t10_h = global_param(71);       % schooling husband - PC
t11_h = global_param(72);       % exp husband  
t12_h = global_param(73);       % martial status if married
t13_h = global_param(74);       % number of children if married
t14_h = global_param(75);       % match quality if married
%t15_h = global_param();        % number of children if married - NO NEED
t16_h = global_param(76);       % previous work state - wife if married
% match quality parameters
P_HUSBAND =        (exp(global_param(77)))/(1+exp(global_param(77)));   % PROBABILITY OF MEETING A POTENTIAL HUSBAND
MATCH_Q_DECREASE = (exp(global_param(78)))/(1+exp(global_param(78)));   % probability of match quality decrease
MATCH_Q_INCREASE = (exp(global_param(79)))/(1+exp(global_param(79)));   % probability of match quality increase
% random shocks variance-covariance matrix
sigma(1,1) = exp(global_param(80));             %wage error variance husband;
sigma(2,2) = exp(global_param(81));             %wage error variance wife;
sigma(3,3) = exp(global_param(82));             % variance wife ability
sigma(4,4) = exp(global_param(83));             % variance husband ability
sigma(5,5) = exp(global_param(84));             % variance match quality


%beta = 0; % - static model !!!
beta = 0.983;       % discount rate
% standart normal distribution array : 5%, 15%, 25%, 35%, 45%, 55%, 65%, 75%, 85%, 95%
%normal_arr = [-1.645, -1.036, -0.674, -0.385, -0.126, 0.126, 0.385, 0.674, 1.036, 1.645];
% standart normal distribution array : 5%, 15%, 25%, 35%, 45%, 55%, 65%, 75%, 85%, 95%

normal_arr = [-1.2817,  -0.524,  0.000,  0.524, 1.2817];
bp_vector = [0, 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1 ];
%%%%%%%%%%%%%%%%%%
% INITIALIZATION %
%%%%%%%%%%%%%%%%%%
%individual moments:
%employment moments
emp =               zeros(DRAW_F,T_MAX, SCHOOL_GROUPS);         % employment total
emp_m =             zeros(DRAW_F,T_MAX, SCHOOL_GROUPS);         % employment married
emp_m_up =          zeros(DRAW_F,T_MAX, SCHOOL_GROUPS);         % employment married up
emp_m_down =        zeros(DRAW_F,T_MAX, SCHOOL_GROUPS);         % employment married down
emp_m_eq =          zeros(DRAW_F,T_MAX, SCHOOL_GROUPS);         % employment married equal
count_emp_m_up =    zeros(T_MAX, SCHOOL_GROUPS);                % employment married up
count_emp_m_down =  zeros(T_MAX, SCHOOL_GROUPS);                % employment married down
count_emp_m_eq =    zeros(T_MAX, SCHOOL_GROUPS);                % employment married equal
emp_m_no_kids =     zeros(DRAW_F,T_MAX, SCHOOL_GROUPS);         % employment married no kids
emp_m_one_kid =     zeros(DRAW_F,T_MAX, SCHOOL_GROUPS);         % employment married 1 kid
emp_m_2_3_kids =    zeros(DRAW_F,T_MAX, SCHOOL_GROUPS);         % employment married 2-3 kids
emp_m_4plus_kids =  zeros(DRAW_F,T_MAX, SCHOOL_GROUPS);         % employment married 4  kids
count_emp_m_no_kids =    zeros(T_MAX, SCHOOL_GROUPS);   
count_emp_m_one_kid =    zeros(T_MAX, SCHOOL_GROUPS);   
count_emp_m_2_3_kids =   zeros(T_MAX, SCHOOL_GROUPS);   
count_emp_m_4plus_kids = zeros(T_MAX, SCHOOL_GROUPS);
emp_m_no_y_kids=    zeros(DRAW_F,T_MAX, SCHOOL_GROUPS);         % employment married no kids
emp_m_one_y_kid=    zeros(DRAW_F,T_MAX, SCHOOL_GROUPS);         % employment married 1 kid
emp_m_2_3_y_kids=   zeros(DRAW_F,T_MAX, SCHOOL_GROUPS);         % employment married 2-3 kids
emp_m_4plus_y_kids= zeros(DRAW_F,T_MAX, SCHOOL_GROUPS);         % employment married 4  kids
emp_m_no_o_kids=    zeros(DRAW_F,T_MAX, SCHOOL_GROUPS);         % employment married no kids
emp_m_one_o_kid=    zeros(DRAW_F,T_MAX, SCHOOL_GROUPS);         % employment married 1 kid
emp_m_2_3_o_kids=   zeros(DRAW_F,T_MAX, SCHOOL_GROUPS);         % employment married 2-3 kids
emp_m_4plus_o_kids= zeros(DRAW_F,T_MAX, SCHOOL_GROUPS);         % employment married 4  kids
count_emp_m_no_y_kids =    zeros(T_MAX, SCHOOL_GROUPS); 
count_emp_m_one_y_kid =    zeros(T_MAX, SCHOOL_GROUPS); 
count_emp_m_2_3_y_kids =   zeros(T_MAX, SCHOOL_GROUPS); 
count_emp_m_4plus_y_kids = zeros(T_MAX, SCHOOL_GROUPS); 
count_emp_m_no_o_kids =    zeros(T_MAX, SCHOOL_GROUPS); 
count_emp_m_one_o_kid =    zeros(T_MAX, SCHOOL_GROUPS); 
count_emp_m_2_3_o_kids =   zeros(T_MAX, SCHOOL_GROUPS); 
count_emp_m_4plus_o_kids = zeros(T_MAX, SCHOOL_GROUPS); 
emp_um =               zeros(DRAW_F,T_MAX, SCHOOL_GROUPS);          % employment unmarried
emp_um_no_kids =       zeros(DRAW_F,T_MAX, SCHOOL_GROUPS);          % employment unmarried and no children
emp_um_kids =          zeros(DRAW_F,T_MAX, SCHOOL_GROUPS);          % employment unmarried and children
count_emp_um_no_kids = zeros(T_MAX, SCHOOL_GROUPS);
count_emp_um_kids =    zeros(T_MAX, SCHOOL_GROUPS);
just_found_job =       zeros(DRAW_F,T_MAX, SCHOOL_GROUPS);          % for transition matrix - unemployment to employment 
just_got_fired =       zeros(DRAW_F,T_MAX, SCHOOL_GROUPS);          % for transition matrix - employment to unemployment
% wages moments
wages_m_h =         ones(DRAW_F,48, SCHOOL_GROUPS+1).*-99999;  % married men wages - 0 until 20+27 years of exp - 36-47 will be ignore in moments  
wages_w =           ones(DRAW_F,T_MAX, SCHOOL_GROUPS).*-99999;  % women wages if employed
wages_m_w =         ones(DRAW_F,T_MAX, SCHOOL_GROUPS).*-99999;  % married women wages if employed
wages_m_h_up =      ones(DRAW_F,48, SCHOOL_GROUPS+1).*-99999;  % married up men wages 
wages_m_h_down =    ones(DRAW_F,48, SCHOOL_GROUPS+1).*-99999;  % married down men wages 
wages_m_h_eq =      ones(DRAW_F,48, SCHOOL_GROUPS+1).*-99999;  % married equal men wages 
wages_m_w_up =      ones(DRAW_F,T_MAX, SCHOOL_GROUPS).*-99999;  % married up women wages if employed
wages_m_w_down =    ones(DRAW_F,T_MAX, SCHOOL_GROUPS).*-99999;  % married down women wages if employed
wages_m_w_eq =      ones(DRAW_F,T_MAX, SCHOOL_GROUPS).*-99999;  % married equal women wages if employed
count_wages_m_h_up =    zeros(48, SCHOOL_GROUPS+1);     % count observation of married up men wages 
count_wages_m_h_down =  zeros(48, SCHOOL_GROUPS+1);     % count observation of married down men wages 
count_wages_m_h_eq =    zeros(48, SCHOOL_GROUPS+1);       % count observation of married equal men wages 
count_wages_m_w_up =    zeros(T_MAX, SCHOOL_GROUPS);  % count observation of married up women wages if employed
count_wages_m_w_down =  zeros(T_MAX, SCHOOL_GROUPS);  % count observation of married down women wages if employed
count_wages_m_w_eq =    zeros(T_MAX, SCHOOL_GROUPS);  % count observation of married equal women wages if employed
wages_um_w =        ones(DRAW_F,T_MAX, SCHOOL_GROUPS).*-99999;  % unmarried women wages if employed
% fertilty and marriage rate moments
married               =   zeros(DRAW_F,T_MAX, SCHOOL_GROUPS);       % married yes/no
just_married          =   zeros(DRAW_F,T_MAX, SCHOOL_GROUPS);       %for transition matrix from single to married
age_at_first_marriage =   zeros(DRAW_F, SCHOOL_GROUPS);             %age at first marriage
just_divorced         =   zeros(DRAW_F,T_MAX, SCHOOL_GROUPS);       %for transition matrix from married to divorce
newborn               =   zeros(DRAW_F,T_MAX, SCHOOL_GROUPS);       % new born in period t - for probability and distribution
duration_of_first_marriage  = zeros(DRAW_F, SCHOOL_GROUPS);         % duration of marriage if divorce or 45-age of marriage if still married at 45.
count_duration_of_first_marriage = zeros(SCHOOL_GROUPS,1);
assortative_mating    =   zeros(DRAW_F, SCHOOL_GROUPS);             % HUSBAND EDUCATION BY WIFE EDUCATION
%average moments
average_marr = zeros(T_MAX);
f_div = zeros(T_MAX);
f_y_kids = zeros(T_MAX,4);
f_o_kids = zeros(T_MAX,4);
f_wages = zeros(T_MAX,1);  % average_wages(t) is the average wage of workers in year t
f_emp = zeros(T_MAX); % emp is the proportion of employment in period t
f_emp_m = zeros(T_MAX); % emp is the proportion of employment in period t
f_emp_um = zeros(T_MAX); % emp is the proportion of employment in period t
%transition matrix moments

for school_group=1 : 5       % school_group 1 is only for calculating the emax if single men, other than that, there is a "if school_group>1"
    if school_group == 1
        HSG = 0;  SC = 0;  CG = 0; PC = 0;
        H_HSG = 0; H_SC = 0; H_CG = 0; H_PC = 0;
        HSD = 1;
        HS = 1; H_HSD = 1;
        AGE = 18;
        T= TERMINAL - AGE+1; 
        age_index = 0;
    elseif school_group == 2
        HSD = 0; HSG = 0;  SC = 0;  CG = 0; PC = 0;
        H_HSD = 0; H_HSG = 0; H_SC = 0; H_CG = 0; H_PC = 0;
        HSG = 1;
        HS = 2; H_HSG = 1;
        AGE = 18;
        T= TERMINAL - AGE+1; 
        age_index = 0;
    elseif school_group == 3    
        HSD = 0; HSG = 0;  SC = 0;  CG = 0; PC = 0;
        H_HSD = 0; H_HSG = 0; H_SC = 0; H_CG = 0; H_PC = 0;
        SC = 1;
        HS = 3; H_SC = 1;
        AGE = 20;
        T = TERMINAL - AGE+1;
        age_index = 2;
    elseif school_group == 4
        HSD = 0; HSG = 0;  SC = 0;  CG = 0; PC = 0;
        H_HSD = 0; H_HSG = 0; H_SC = 0; H_CG = 0; H_PC = 0;
        CG = 1;
        HS = 4; H_CG = 1;
        AGE = 22;
        T = TERMINAL - AGE+1;
        age_index = 4;
    else
        HSD = 0; HSG = 0;  SC = 0;  CG = 0; PC = 0;
        H_HSD = 0; H_HSG = 0; H_SC = 0; H_CG = 0; H_PC = 0;
        PC = 1;
        HS = 5; H_PC = 1;
        AGE = 25;
        T = TERMINAL - AGE+1;   
        age_index = 7;
    end
    
    % EMAX dimensions are
    %period, experience, # of young children,# of old children,prev_state, wife ability, mar_state,husband exp,husband schooling,match quality, ability_h_index, bp
    EMAX_W = zeros(T,T+1,4,4,2,5,2,EMAX21,5,5,5,3); 
    EMAX_H = zeros(T,T+1,4,4,2,5,2,EMAX21,5,5,5,3); 
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % SOLVING BACKWARDS - FILLING THE EMAX %
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    for t = T : -1 : 1 %TIME
        % % husbands cohort characteristics - P_HUSBAND=husbands(t,1);
        P_HSD_0=husbands(t+age_index,2);
        P_HSD_5=husbands(t+age_index,3);
        P_HSD_10=husbands(t+age_index,4);
        P_HSD_20=husbands(t+age_index,5);
        P_HSG_0=husbands(t+age_index,6);
        P_HSG_5=husbands(t+age_index,7);
        P_HSG_10=husbands(t+age_index,8);
        P_HSG_20=husbands(t+age_index,9);
        P_SC_0=husbands(t+age_index,10);
        P_SC_5=husbands(t+age_index,11);
        P_SC_10=husbands(t+age_index,12);
        P_SC_20=husbands(t+age_index,13);
        P_CG_0=husbands(t+age_index,14);
        P_CG_5=husbands(t+age_index,15);
        P_CG_10=husbands(t+age_index,16);
        P_CG_20=husbands(t+age_index,17);
        P_PC_0=husbands(t+age_index,18);
        P_PC_5=husbands(t+age_index,19);
        P_PC_10=husbands(t+age_index,20);
        P_PC_20=husbands(t+age_index,21);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   EMAX FOR SINGLE MEN     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % wife cohort characteristics 
        P_1=wives(t+age_index,2);
        P_2=wives(t+age_index,3);
        P_3=wives(t+age_index,4);
        P_4=wives(t+age_index,5);
        P_5=wives(t+age_index,6);
        P_6=wives(t+age_index,7);
        P_7=wives(t+age_index,8);
        P_8=wives(t+age_index,9);
        P_9=wives(t+age_index,10);
        P_10=wives(t+age_index,11);
        P_11=wives(t+age_index,12);
        P_12=wives(t+age_index,13); 
        P_13=wives(t+age_index,14);
        P_14=wives(t+age_index,15);
        P_15=wives(t+age_index,16);
        P_16=wives(t+age_index,17);
        P_17=wives(t+age_index,18);
        P_18=wives(t+age_index,19);
        P_19=wives(t+age_index,20);
        P_20=wives(t+age_index,21);
        P_21=wives(t+age_index,22);
        P_22=wives(t+age_index,23);
        P_23=wives(t+age_index,24);
        P_24=wives(t+age_index,25); 
        P_25=wives(t+age_index,26);
        P_26=wives(t+age_index,27);
        P_27=wives(t+age_index,28);
        P_28=wives(t+age_index,29);
        P_29=wives(t+age_index,30);
        P_30=wives(t+age_index,31);
        P_31=wives(t+age_index,32);
        P_32=wives(t+age_index,33);
    
        if t<21
		    for H_EXP = 0:t %HUSBAND EXPERENCE
                for ability_h_index = 1:5   %husband ability
                    ability_h = normal_arr(ability_h_index)*sigma(4,4);
                    for draw_b = 1 : DRAW_B
                        % DRAW A WIFE 
                        K = 0;
                        M = 0;
                        D = 0;
                        Q = 0;
                        N_Y = 0;
                        N_O = 0;
                        HSD = 0; HSG = 0; SC = 0; CG = 0; PC = 0;
        %w_draws_b = rand(DRAW_B, T_MAX, SCHOOL_GROUPS, 6);%1- wife; 2-wife EXP+SCHOOLING; 3-wife ABILITY; 4 - INITIAL MATCH QUALITY; 5 - JOB OFFER FOR MARRIED MEN AND WOMEN EMAX; 6-JOB OFFER FOR SINGLE MEN EMAX 
                        if w_draws_b(draw_b,t,HS,1)<P_HUSBAND %THE PROBABILITY TO DRAW A WIFE IS EQUAL TO THE PROBABILITY TO DRAW HUSBAND?!
                            CHOOSE_WIFE = 1;
                            ability_w = normal_arr(w_draws_b(draw_b,t,HS,3))*sigma(3,3);
                            ability_w_index = w_draws_b(draw_b,t,HS,3);
                            Q = normal_arr(w_draws_b(draw_b,t,HS,4))*sigma(5,5);
                            Q_INDEX = w_draws_b(draw_b,t,HS,4);
                            if w_draws_b(draw_b,t,HS,2)<P_1%wife schooling - HSG & UNEMPLOYED IN PREVIOUS PERIOD
                                HSG=1;  
                                K = K0;
                                prev_state = 0;
                            elseif (w_draws_b(draw_b,t,HS,2)>P_1 && w_draws_b(draw_b,t,HS,2)<P_2)
                                HSG=1;  
                                K = K5;
                                prev_state = 0;
                            elseif (w_draws_b(draw_b,t,HS,2)>P_2 && w_draws_b(draw_b,t,HS,2)<P_3)
                                HSG=1;  
                                K = K10;
                                prev_state = 0;
                            elseif (w_draws_b(draw_b,t,HS,2)>P_3 && w_draws_b(draw_b,t,HS,2)<P_4)
                                HSG=1;  
                                K = K20; 
                                prev_state = 0;
                            elseif (w_draws_b(draw_b,t,HS,2)>P_4 && w_draws_b(draw_b,t,HS,2)<P_5) %wife schooling - HSG & EMPLOYED IN PREVIOUS PERIOD
                                HSG=1;  
                                K = K0;
                                prev_state = 1;                                     
                            elseif w_draws_b(draw_b,t,HS,2)>P_5 && w_draws_b(draw_b,t,HS,2)<P_6
                                HSG=1;  
                                K = K5;  
                                prev_state = 1; 
                            elseif w_draws_b(draw_b,t,HS,2)>P_6 && w_draws_b(draw_b,t,HS,2)<P_7
                                HSG=1;  
                                K = K10; 
                                prev_state = 1; 
                            elseif w_draws_b(draw_b,t,HS,2)>P_7 && w_draws_b(draw_b,t,HS,2)<P_8
                                HSG=1;  
                                K = K20; 
                                prev_state = 1; 
                            elseif (w_draws_b(draw_b,t,HS,2)>P_8 && w_draws_b(draw_b,t,HS,2)<P_9) %wife schooling - SC & UNEMPLOYED IN PREVIOUS PERIOD
                                SC=1;  
                                K = K0;
                                prev_state = 0;
                            elseif (w_draws_b(draw_b,t,HS,2)>P_9 && w_draws_b(draw_b,t,HS,2)<P_10) 
                                SC=1;  
                                K = K5;
                                prev_state = 0;
                            elseif (w_draws_b(draw_b,t,HS,2)>P_10 && w_draws_b(draw_b,t,HS,2)<P_11)
                                SC=1;  
                                K = K10;
                                prev_state = 0;
                            elseif (w_draws_b(draw_b,t,HS,2)>P_11 && w_draws_b(draw_b,t,HS,2)<P_12)
                                SC=1;  
                                K = K20; 
                                prev_state = 0;
                            elseif (w_draws_b(draw_b,t,HS,2)>P_12 && w_draws_b(draw_b,t,HS,2)<P_13) %wife schooling - SC & EMPLOYED IN PREVIOUS PERIOD
                                SC=1;  
                                K = K0;
                                prev_state = 1;                                     
                            elseif w_draws_b(draw_b,t,HS,2)>P_13 && w_draws_b(draw_b,t,HS,2)<P_14
                                SC=1;  
                                K = K5;  
                                prev_state = 1; 
                            elseif w_draws_b(draw_b,t,HS,2)>P_14 && w_draws_b(draw_b,t,HS,2)<P_15
                                SC=1;  
                                K = K10; 
                                prev_state = 1; 
                            elseif w_draws_b(draw_b,t,HS,2)>P_15 && w_draws_b(draw_b,t,HS,2)<P_16
                                SC=1;  
                                K = K20; 
                                prev_state = 1; 
                            elseif (w_draws_b(draw_b,t,HS,2)>P_16 && w_draws_b(draw_b,t,HS,2)<P_17) %wife schooling - CG & UNEMPLOYED IN PREVIOUS PERIOD
                                CG=1;  
                                K = K0;
                                prev_state = 0;
                            elseif (w_draws_b(draw_b,t,HS,2)>P_17 && w_draws_b(draw_b,t,HS,2)<P_18)
                                CG=1;  
                                K = K5;
                                prev_state = 0;
                            elseif (w_draws_b(draw_b,t,HS,2)>P_18 && w_draws_b(draw_b,t,HS,2)<P_19)
                                CG=1;  
                                K = K10;
                                prev_state = 0;
                            elseif (w_draws_b(draw_b,t,HS,2)>P_19 && w_draws_b(draw_b,t,HS,2)<P_20)
                                CG=1;  
                                K = K20; 
                                prev_state = 0;
                            elseif (w_draws_b(draw_b,t,HS,2)>P_20 && w_draws_b(draw_b,t,HS,2)<P_21) %wife schooling - CG & EMPLOYED IN PREVIOUS PERIOD
                                CG=1;  
                                K = K0;
                                prev_state = 1;                                     
                            elseif w_draws_b(draw_b,t,HS,2)>P_21 && w_draws_b(draw_b,t,HS,2)<P_22
                                CG=1;  
                                K = K5;  
                                prev_state = 1; 
                            elseif w_draws_b(draw_b,t,HS,2)>P_22 && w_draws_b(draw_b,t,HS,2)<P_23
                                CG=1;  
                                K = K10; 
                                prev_state = 1; 
                            elseif w_draws_b(draw_b,t,HS,2)>P_23 && w_draws_b(draw_b,t,HS,2)<P_24
                                CG=1;  
                                K = K20; 
                                prev_state = 1; 
                            elseif (w_draws_b(draw_b,t,HS,2)>P_24 && w_draws_b(draw_b,t,HS,2)<P_25) %wife schooling - PC & UNEMPLOYED IN PREVIOUS PERIOD
                                PC=1;  
                                K = K0;
                                prev_state = 0;
                            elseif (w_draws_b(draw_b,t,HS,2)>P_25 && w_draws_b(draw_b,t,HS,2)<P_26)
                                PC=1;  
                                K = K5;
                                prev_state = 0;
                            elseif (w_draws_b(draw_b,t,HS,2)>P_26 && w_draws_b(draw_b,t,HS,2)<P_27)
                                PC=1;  
                                K = K10;
                                prev_state = 0;
                            elseif (w_draws_b(draw_b,t,HS,2)>P_27 && w_draws_b(draw_b,t,HS,2)<P_28)
                                PC=1;  
                                K = K20; 
                                prev_state = 0;
                            elseif (w_draws_b(draw_b,t,HS,2)>P_28 && w_draws_b(draw_b,t,HS,2)<P_29) %wife schooling - PC & EMPLOYED IN PREVIOUS PERIOD
                                PC=1;  
                                K = K0;
                                prev_state = 1;                                     
                            elseif w_draws_b(draw_b,t,HS,2)>P_29 && w_draws_b(draw_b,t,HS,2)<P_30
                                PC=1;  
                                K = K5;  
                                prev_state = 1; 
                            elseif w_draws_b(draw_b,t,HS,2)>P_30 && w_draws_b(draw_b,t,HS,2)<P_31
                                PC=1;  
                                K = K10; 
                                prev_state = 1; 
                            elseif w_draws_b(draw_b,t,HS,2)>P_31 && w_draws_b(draw_b,t,HS,2)<P_32
                                PC=1;  
                                K = K20; 
                                prev_state = 1; 
                            end
                            % JOB OFFER PROBABILITY + WAGE WIFE
                            PROB_TMP=row0*prev_state + row11*HSG +row12*SC +row13*CG +row14*PC + row2*K;
                            PROB_W= exp(PROB_TMP) ./ (1+exp(PROB_TMP));
                            if PROB_W > w_draws_b(draw_b,t,HS,6)
                                CHOOSE_WORK = 1;
                                tmp1_w = ability_w + beta1_w*K + beta2_w*K.^2 + beta31_w*HSG+beta32_w*SC+ beta33_w*CG+ beta34_w*PC;
                                tmp2_w = (epsilon_b(draw_b, t, HS,2)*sigma(2,2)); %epsilon_b(draw_b, t,school_group, sex)  
                                wage_w = exp(tmp1_w + tmp2_w);
                            else
                                CHOOSE_WORK = 0;
                                wage_w = 0;
                            end
                        else
                            CHOOSE_WIFE = 0;
                            CHOOSE_WORK = 0;
                            wage_w = 0;
                        end 
                        tmp1_h = ability_h + beta1_h*(H_EXP)+ beta2_h*(H_EXP).^2+ beta30_h*H_HSD+beta31_h*H_HSG+ beta32_h*H_SC+ beta33_h*H_CG+ beta34_h*H_PC;
                        tmp2_h = (epsilon_b(draw_b, t,HS,1)*sigma(1,1)); %epsilon_b(draw_b, t, sex)
                        wage_h = exp(tmp1_h + tmp2_h);
                        
                        % decision making - choose from up to 4 options, according to CHOOSE_HUSBAND and CHOOSE_WORK values
                        % utility from each option:
                        % home production - equal for both partners:             1-singe+unemployed
                                        %                                        2-singe+employed
                                        %                                        3-married+unemployed
                                        %                                        4-married+eployed
                        %home production technology - parameters    
                        %   HP(S)=((1+hp1*N_Y+hp2*N_O)*(hp3+hp4)^hp7+(1+hp5*N_Y+hp6*N_O)*(wage_w+wage_h)^hp7)^(1/hp7);
                        HP(1)=((1+hp1*N_Y+hp2*N_O)*(hp4)^hp7+(1+hp5*N_Y+hp6*N_O)*(0)^hp7)^(1/hp7);
                        HP(2)=((1+hp1*N_Y+hp2*N_O)*(0)^hp7+(1+hp5*N_Y+hp6*N_O)*(wage_w)^hp7)^(1/hp7);%all cancel out but wage_w if no kids
                        HP(3)=((1+hp1*N_Y+hp2*N_O)*(hp4)^hp7+(1+hp5*N_Y+hp6*N_O)*(wage_h)^hp7)^(1/hp7);
                        HP(4)=((1+hp1*N_Y+hp2*N_O)*(0)^hp7+(1+hp5*N_Y+hp6*N_O)*(wage_h+wage_w)^hp7)^(1/hp7);
                        % wife utility from each option
                        % U_W(S)=HP(S)+alpha1+alpha21*N_Y+alpha22*N_O+alpha3*M*Q+alpha41*M*N_Y+alpha42*M*N_O;                   
                        %scale_w = 1 + M*0.7 + (N_Y+N_O)*0.4;
                        UC_W(1)=(((HP(1)/(1+(N_Y+N_O)*0.4))^hp8)/hp8)+alpha1_w+alpha21_w*N_Y+alpha22_w*N_O;
                        UC_W(2)=(((HP(2)/(1+(N_Y+N_O)*0.4))^hp8)/hp8)         +alpha21_w*N_Y+alpha22_w*N_O;
                        UC_W(3)=(((HP(3)/(1.7+(N_Y+N_O)*0.4))^hp8)/hp8)+alpha1_w+alpha21_w*N_Y+alpha22_w*N_O+Q+alpha31_w*N_Y+alpha32_w*N_O;
                        UC_W(4)=(((HP(4)/(1.7+(N_Y+N_O)*0.4))^hp8)/hp8)        +alpha21_w*N_Y+alpha22_w*N_O+Q+alpha31_w*N_Y+alpha32_w*N_O;
                        if t == T
                            %t1 schooling wife - HSG, t2 schooling wife - SC, t3 schooling wife - CG, t4 schooling wife - PC, t5 exp wife
                            %t6 schooling husband if married - HSD, t7 schooling husband - HSG, t8 Shooling husband - SC, t9 Schooling husband CG, t10 schooling husband- PC
                            %t11 exp husband if married, t12 martial status, t13 number of children, t14 match quality if married, t15 number of children if married
                            %t16 previous work state - wife, 
                            U_W(1)=UC_W(1)+t1_w*HSG+t2_w*SC+t3_w*CG+t4_w*PC+t5_w*K+t13_w*(N_Y+N_O);     
                            U_W(2)=UC_W(2)+t1_w*HSG+t2_w*SC+t3_w*CG+t4_w*PC+t5_w*(K+1)+t13_w*(N_Y+N_O)+t16_w;       
                            U_W(3)=UC_W(3)+t1_w*HSG+t2_w*SC+t3_w*CG+t4_w*PC+t5_w*K+t6_w*H_HSD+t7_w*H_HSG+t8_w*H_SC+t9_w*H_CG+t10_w*H_PC+t11_w*(H_EXP+1)+t12_w+t13_w*(N_Y+N_O)+t14_w*Q+t15_w*(N_Y+N_O);      
                            U_W(4)=UC_W(4)+t1_w*HSG+t2_w*SC+t3_w*CG+t4_w*PC+t5_w*(K+1)+t6_w*H_HSD+t7_w*H_HSG+t8_w*H_SC+t9_w*H_CG+t10_w*H_PC+t11_w*(H_EXP+1)+t12_w+t13_w*(N_Y+N_O)+t14_w*Q+t15_w*(N_Y+N_O)+t16_w;        
                        else
                            % EMAX(t,K,N_Y,N_O,prev_state,ability_w_index,M,HE+t,HS,Q_INDEX, ability_h_index, bp)

                            U_W(1)=UC_W(1)+beta*EMAX_W(t+1, K+1, N_Y+1, N_O+1, 0+1, ability_w_index, 0+1, 1, 1, 1, 1, 1);
                            U_W(2)=UC_W(2)+beta*EMAX_W(t+1, K+2, N_Y+1, N_O+1, 1+1, ability_w_index, 0+1, 1, 1, 1, 1, 1);
                            U_W(3)=UC_W(3)+beta*EMAX_W(t+1, K+1, N_Y+1, N_O+1, 0+1, ability_w_index, 1+1, (H_EXP+1)+1, HS, Q_INDEX, ability_h_index, 2);
                            U_W(4)=UC_W(4)+beta*EMAX_W(t+1,K+2,N_Y+1,N_O+1,1+1,ability_w_index,1+1,(H_EXP+1)+1,HS,Q_INDEX,ability_h_index,2);
                        end
                    
                        if M == 0  &&  CHOOSE_WIFE == 0
                            U_W(3)  = -99999;
                            U_W(4)  = -99999;
                        end
                        if CHOOSE_WORK == 0
                            U_W(2) = -99999;
                            U_W(4) = -99999;
                        end
                        % husband CURRENT utility from four options
                        % U_H(S)=HP(S)+alpha1+alpha21*N_Y+alpha22*N_O+alpha3*M*Q+alpha41*M*N_Y+alpha42*M*N_O;       
                        UC_H(1)= -99999;
                        UC_H(2)=((wage_h^hp8)/hp8);
                        UC_H(3)=(((HP(3)/(1.7+(N_Y+N_O)*0.4))^hp8)/hp8)       +alpha21_h*N_Y+alpha22_h*N_O+M*Q;
                        UC_H(4)=(((HP(4)/(1.7+(N_Y+N_O)*0.4))^hp8)/hp8)       +alpha21_h*N_Y+alpha22_h*N_O+M*Q;
                        if t == T
                            %t1 schooling wife - HSG, t2 schooling wife - SC, t3 schooling wife - CG, t4 schooling wife - PC, t5 exp wife
                            %t6 schooling husband if married - HSD, t7 schooling husband - HSG, t8 Shooling husband - SC, t9 Schooling husband CG, t10 schooling husband- PC
                            %t11 exp husband if married, t12 martial status, t13 number of children, t14 match quality if married, t15 number of children if married
                            %t16 previous work state - wife, t17 previous work state - husband
                            U_H(1)= -99999; 
                            U_H(2)=UC_H(2)+t6_h*H_HSD+t7_h*H_HSG+t8_h*H_SC+t9_h*H_CG+t10_h*H_PC+t11_h*(H_EXP+1);        
                            U_H(3)=UC_H(3)+t1_h*HSG+t2_h*SC+t3_h*CG+t4_h*PC+t5_h*K+t6_h*H_HSD+t7_h*H_HSG+t8_h*H_SC+t9_h*H_CG+t10_h*H_PC+t11_h*(H_EXP+1)+t12_h+t13_h*(N_Y+N_O)+t14_h*Q;      
                            U_H(4)=UC_H(4)+t1_h*HSG+t2_h*SC+t3_h*CG+t4_h*PC+t5_h*(K+1)+t6_h*H_HSD+t7_h*H_HSG+t8_h*H_SC+t9_h*H_CG+t10_h*H_PC+t11_h*(H_EXP+1)+t12_h+t13_h*(N_Y+N_O)+t14_h*Q+t16_h;        
                        else
                            % EMAX(t,K,N_Y,N_O,prev_state,ability_w_index,M,HE+t,HS,Q_INDEX, ability_h_index, bp)
                            U_H(1)= -99999;
                            U_H(2)=UC_H(2)+beta*EMAX_H(t+1,1,1,1,1,1,1,(H_EXP+1)+1,HS,1,ability_h_index,1);
                            U_H(3)=UC_H(3)+beta*EMAX_H(t+1,K+1,N_Y+1,N_O+1,0+1,ability_w_index,1+1,(H_EXP+1)+1,HS,Q_INDEX,ability_h_index,2);
                            U_H(4)=UC_H(4)+beta*EMAX_H(t+1,K+2,N_Y+1,N_O+1,1+1,ability_w_index,1+1,(H_EXP+1)+1,HS,Q_INDEX,ability_h_index,2);
                        end
                        if M == 0  &&  CHOOSE_WIFE == 0
                            U_H(3)  = -99999;
                            U_H(4)  = -99999;
                        end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %   MAXIMIZATION - MARRIAGE + WORK DESICION                        %
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                        % marriage decision - outside option value wife
                        if U_W(1)>U_W(2)
                            outside_option_w_v = U_W(1);
                            %outside_option_w = 1; %"unemployed"
                        else        
                            outside_option_w_v = U_W(2);
                            %outside_option_w = 2; %employed
                        end
                        if U_W(3)> outside_option_w_v && U_W(4)> outside_option_w_v 
                            if U_H(3)>U_H(2) && U_H(4)>U_H(2) %WILL GET MARRIE AND CHOOSE MAX
                            %%%%%%%%%%%%%%  Nash bergaining at first period of marriage  %%%%%%%%%%%%%%%%%%%%%%%%%%
                                nash_value_3 =(U_W(3)-outside_option_w_v)*(U_H(3)-U_H(2)) ;  %value if married and women unemployed
                                nash_value_4 =(U_W(4)-outside_option_w_v)*(U_H(4)-U_H(2))  ; %value if married and women unemployed
                                if (nash_value_3>nash_value_4)
                                    M = 1 ;
                                    emp = 0;
                                elseif (nash_value_4>nash_value_3)
                                    M = 1 ;
                                    emp = 1;
                                end 
                            elseif U_H(3)>U_H(2) && U_H(4)<U_H(2) %WILL GET MARRIE AND NOT WORK - CHOOSE 3
                                M = 1 ;
                                emp = 0;
                            elseif U_H(4)>U_H(2) && U_H(3)<U_H(2) %WILL GET MARRIE AND WORK - CHOOSE 4
                                M = 1 ;
                                emp = 1;
                            elseif U_H(3)<U_H(2) && U_H(4)<U_H(2) %WILL NOT GET MARRIE 
                                M = 0 ;
                                if U_W(1) == outside_option_w_v      %WILL NOT WORK AND SINGLE, CHOOSE 1
                                    emp = 0;
                                else                                %WILL WORK AND SINGLE, CHOOSE 2
                                    emp = 1;
                                end
                            end
                        elseif  U_W(3)> outside_option_w_v && U_W(4)< outside_option_w_v %WILL NOT WORK IF MARRIED
                            if U_H(3)>U_H(2)  %WILL GET MARIED, WILL NOT WORK, CHOOSE 3
                                M = 1 ;
                                emp = 0;
                            elseif U_H(3)<U_H(2) %WILL NOT GET MARIED
                                M = 0 ;
                                if U_W(1) == outside_option_w_v  %WILL NOT WORK AND SINGLE, CHOOSE 1
                                    emp = 0;
                                else                           % WILL WORK AS SINGLE, CHOOSE 2
                                    emp = 1;
                                end
                            end 
                        elseif  U_W(4)> outside_option_w_v && U_W(3)< outside_option_w_v %WILL WORK IF MARRIED 
                            if U_H(4)>U_H(2) %WILL GET MARIED, WILL WORK, CHOOSE 4
                                M = 1 ;
                                emp = 1;
                            elseif U_H(4)<U_H(2)  %WILL NOT GET MARIED
                                M = 0 ;
                                if U_W(1) == outside_option_w_v %WILL NOT WORK AND SINGLE, CHOOSE 1 
                                    emp = 0;
                                else                          % WILL WORK AS SINGLE, CHOOSE 2
                                    emp = 1;
                                end
                            end 
                        elseif  U_W(4)< outside_option_w_v && U_W(3)< outside_option_w_v % WILL NOT MARRIED
                            M = 0 ;
                            if U_W(1) == outside_option_w_v %WILL NOT WORK AND SINGLE, CHOOSE 1
                                emp = 0;
                            else                            % WILL WORK AS SINGLE, CHOOSE 2
                                emp = 1;
                            end
                        end
                        if M == 0 
                            emax_draw_h(draw_b) = U_H(2);
                        elseif M == 1 && emp == 0
                            emax_draw_h(draw_b) = U_H(3);
                        elseif M == 1 && emp == 1
                            emax_draw_h(draw_b) = U_H(4);   
                        end
                    end % close draw_b loop 
                    % emax is the average of emax_draw over the draws
                    emax_h = mean(emax_draw_h);
                    % EMAX(t,K,N_Y,N_O,prev_state,ability_w_index,M,HE+t,HS,Q_INDEX, ability_h_index, bp)
                    EMAX_H(t,1,0+1,0+1,0+1,0+1,0+1,H_EXP+1,HS,0+1,ability_h_index,2)= emax_h;%EMAX of a single men
                end   % close ability loop  
            end  %close H_EXP loop
		end  %close if t<21
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%     
        if school_group > 1  % do not run all the rest of the EMAX for HSD women
            H_HSD = 0; H_HSG = 0; H_SC = 0; H_CG = 0; H_PC = 0;   %update the schooling since it was distroyed in the single men EMAX
            if school_group == 2
                HSD = 0; HSG = 1;  SC = 0;  CG = 0; PC = 0;
            elseif school_group == 3    
                HSD = 0; HSG = 0;  SC = 1;  CG = 0; PC = 0;
            elseif school_group == 4
                HSD = 0; HSG = 0;  SC = 0; CG = 1; PC = 0;
            elseif school_group == 5
                HSD = 0; HSG = 0;  SC = 0;  CG = 0;     PC = 1;
            end
            for N_Y = 0 : 3 %young children
                for N_O = 0 : 3 % old children
                    for prev_state = 0 : 1 % previous state loop
                        for ability_w_index = 1:5   %wife ability
                            ability_w = normal_arr(ability_w_index)*sigma(3,3);
                            for K = 1: t+1
                                for M_T_minus_1 = 0 : 1 % martial status - 0 - unmarried, 1 - married
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   EMAX FOR SINGLE WOMEN     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp(strcat(strftime('%X',localtime(time)), ': EMAX for a single woman'));
                                    if M_T_minus_1 == 0
                                        for draw_b = 1 : DRAW_B
                                            D = 0;
                                            Q = 0;
                                            M = 0;
                                            HS = 1;
                                            H_HSD = 0 ; H_HSG = 0; H_SC = 0; H_CG = 0; H_PC = 0; HE = 0;
                                            if h_draws_b(draw_b,t,school_group,1)<P_HUSBAND
                                                CHOOSE_HUSBAND = 1;
                                                ability_h = normal_arr(h_draws_b(draw_b,t,school_group,3))*sigma(4,4);
                                                ability_h_index = h_draws_b(draw_b,t,school_group,3);
                                                Q = normal_arr(h_draws_b(draw_b,t,school_group,4))*sigma(5,5);
                                                Q_INDEX = h_draws_b(draw_b,t,school_group,4);
                                                if h_draws(draw_b,t,school_group,2)<P_HSD_0%husband schooling HSD
                                                    HS=1;
                                                    H_HSD=1;
                                                    HE = HE0;
                                                elseif (h_draws(draw_b,t,school_group,2)>P_HSD_0 && h_draws(draw_b,t,school_group,2)<P_HSD_5)
                                                    HS=1;
                                                    H_HSD=1;
                                                    HE = HE5;
                                                elseif (h_draws(draw_b,t,school_group,2)>P_HSD_5 && h_draws(draw_b,t,school_group,2)<P_HSD_10)
                                                    HS=1;
                                                    H_HSD=1;
                                                    HE = HE10;
                                                elseif (h_draws(draw_b,t,school_group,2)>P_HSD_10 && h_draws(draw_b,t,school_group,2)<P_HSD_20)
                                                    HS=1;
                                                    H_HSD=1;
                                                    HE = HE20;    
                                                elseif (h_draws(draw_b,t,school_group,2)>P_HSD_20 && h_draws(draw_b,t,school_group,2)<P_HSG_0) %husband schooling HSG
                                                    HS=2;
                                                    H_HSG=1;
                                                    HE = HE0; 
                                                elseif h_draws(draw_b,t,school_group,2)>P_HSG_0 && h_draws(draw_b,t,school_group,2)<P_HSG_5
                                                    HS=2;
                                                    H_HSG=1;
                                                    HE = HE5; 
                                                elseif h_draws(draw_b,t,school_group,2)>P_HSG_5 && h_draws(draw_b,t,school_group,2)<P_HSG_10
                                                    HS=2;
                                                    H_HSG=1;
                                                    HE = HE10;    
                                                elseif h_draws(draw_b,t,school_group,2)>P_HSG_10 && h_draws(draw_b,t,school_group,2)<P_HSG_20
                                                    HS=2;
                                                    H_HSG=1;
                                                    HE = HE20;    
                                                elseif h_draws(draw_b,t,school_group,2)>P_HSG_20 && h_draws(draw_b,t,school_group,2)<P_SC_0  %husband schooling SC
                                                    HS=3;
                                                    H_SC=1;
                                                    HE = HE0; 
                                                elseif h_draws(draw_b,t,school_group,2)>P_SC_0 && h_draws(draw_b,t,school_group,2)<P_SC_5
                                                    HS=3;
                                                    H_SC=1;
                                                    HE = HE5; 
                                                elseif h_draws(draw_b,t,school_group,2)>P_SC_5 && h_draws(draw_b,t,school_group,2)<P_SC_10
                                                    HS=3;
                                                    H_SC=1;
                                                    HE = HE10;    
                                                elseif h_draws(draw_b,t,school_group,2)>P_SC_10 && h_draws(draw_b,t,school_group,2)<P_SC_20
                                                    HS = 3;
                                                    H_SC = 1;
                                                    HE = HE20;    
                                                elseif h_draws(draw_b,t,school_group,2)>P_SC_20 && h_draws(draw_b,t,school_group,2)<P_CG_0  %husband schooling CG
                                                    HS = 4;
                                                    H_CG=1;
                                                    HE = HE0; 
                                                elseif h_draws(draw_b,t,school_group,2)>P_CG_0 && h_draws(draw_b,t,school_group,2)<P_CG_5
                                                    HS = 4;
                                                    H_CG=1;
                                                    HE = HE5; 
                                                elseif h_draws(draw_b,t,school_group,2)>P_CG_5 && h_draws(draw_b,t,school_group,2)<P_CG_10
                                                    HS = 4;
                                                    H_CG=1;
                                                    HE = HE10;    
                                                elseif h_draws(draw_b,t,school_group,2)>P_CG_10 && h_draws(draw_b,t,school_group,2)<P_CG_20
                                                    HS = 4;
                                                    H_CG = 1;
                                                    HE = HE20;                    
                                                elseif h_draws(draw_b,t,school_group,2)>P_CG_20 && h_draws(draw_b,t,school_group,2)<P_PC_0  %husband schooling PC
                                                    HS = 5;
                                                    H_PC=1;
                                                    HE = HE0; 
                                                elseif h_draws(draw_b,t,school_group,2)>P_PC_0 && h_draws(draw_b,t,school_group,2)<P_PC_5
                                                    HS = 5;
                                                    H_PC=1;
                                                    HE = HE5; 
                                                elseif h_draws(draw_b,t,school_group,2)>P_PC_5 && h_draws(draw_b,t,school_group,2)<P_PC_10
                                                    HS = 5;
                                                    H_PC=1;
                                                    HE = HE10;    
                                                elseif h_draws(draw_b,t,school_group,2)>P_PC_10 && h_draws(draw_b,t,school_group,2)<P_PC_20
                                                    HS = 5;
                                                    H_PC = 1;
                                                    HE = HE20;    
                                                end
                                                % POTENTIAL HUSBAND WAGE
                                                H_HSD = 0; H_HSG = 0; H_SC = 0; H_CG = 0; H_PC = 0;
                                                if HS == 1
                                                    H_HSD = 1;
                                                elseif HS == 2
                                                    H_HSG = 1;
                                                elseif HS == 3
                                                    H_SC = 1;
                                                elseif HS == 4
                                                    H_CG = 1;
                                                elseif HS == 5
                                                    H_PC = 1;
                                                end     
                                                tmp1_h = ability_h + beta1_h*(HE+D)+ beta2_h*(HE+D).^2+ beta30_h*H_HSD+beta31_h*H_HSG+ beta32_h*H_SC+ beta33_h*H_CG+ beta34_h*H_PC;
                                                tmp2_h = (epsilon_b(draw_b, t,school_group,1)*sigma(1,1)); %epsilon_b(draw_b, t, sex)
                                                wage_h = exp(tmp1_h + tmp2_h);
                                            else
                                                CHOOSE_HUSBAND = 0;
                                                wage_h = 0;
                                            end 
                                            % JOB OFFER PROBABILITY + WAGE WIFE
                                            %w_draws = rand(DRAW_B,T,2); 1 -job offer, 2-new child, 
                                            PROB_TMP=row0*prev_state + row11*HSG +row12*SC +row13*CG +row14*PC + row2*K;
                                            PROB_W= exp(PROB_TMP) ./ (1+exp(PROB_TMP));
                                            if PROB_W > w_draws_b(draw_b,t,school_group,5)
                                                CHOOSE_WORK = 1;
                                                tmp1_w = ability_w + beta1_w*K + beta2_w*K.^2 + beta31_w*HSG+beta32_w*SC+ beta33_w*CG+ beta34_w*PC;
                                                tmp2_w = (epsilon_b(draw_b, t, school_group,2)*sigma(2,2)); %epsilon_b(draw_b, t, sex)  
                                                wage_w = exp(tmp1_w + tmp2_w);
                                            else
                                                CHOOSE_WORK = 0;
                                                wage_w = 0;
                                            end
                                            % decision making - choose from up to 4 options, according to CHOOSE_HUSBAND and CHOOSE_WORK values
                                            % utility from each option:
                                            % home production - equal for both partners:             1-singe+unemployed
                                                            %                                        2-singe+employed
                                                            %                                        3-married+unemployed
                                                            %                                        4-married+eployed
                                            %home production technology - parameters    
                                            %   HP(S)=((1+hp1*N_Y+hp2*N_O)*(hp3+hp4)^hp7+(1+hp5*N_Y+hp6*N_O)*(wage_w+wage_h)^hp7)^(1/hp7);
                                            HP(1)=((1+hp1*N_Y+hp2*N_O)*(hp4)^hp7+(1+hp5*N_Y+hp6*N_O)*(0)^hp7)^(1/hp7);
                                            HP(2)=((1+hp1*N_Y+hp2*N_O)*(0)^hp7+(1+hp5*N_Y+hp6*N_O)*(wage_w)^hp7)^(1/hp7);%all cancel out but wage_w if no kids
                                            HP(3)=((1+hp1*N_Y+hp2*N_O)*(hp4)^hp7+(1+hp5*N_Y+hp6*N_O)*(wage_h)^hp7)^(1/hp7);
                                            HP(4)=((1+hp1*N_Y+hp2*N_O)*(0)^hp7+(1+hp5*N_Y+hp6*N_O)*(wage_h+wage_w)^hp7)^(1/hp7);
                                            % wife utility from each option
                                            % U_W(S)=HP(S)+alpha1+alpha21*N_Y+alpha22*N_O+alpha3*M*Q+alpha41*M*N_Y+alpha42*M*N_O;                   
                                            %scale_w = 1 + M*0.7 + (N_Y+N_O)*0.4;
                                            UC_W(1)=(((HP(1)/(1+(N_Y+N_O)*0.4))^hp8)/hp8)+alpha1_w+alpha21_w*N_Y+alpha22_w*N_O;
                                            UC_W(2)=(((HP(2)/(1+(N_Y+N_O)*0.4))^hp8)/hp8)         +alpha21_w*N_Y+alpha22_w*N_O;
                                            UC_W(3)=(((HP(3)/(1.7+(N_Y+N_O)*0.4))^hp8)/hp8)+alpha1_w+alpha21_w*N_Y+alpha22_w*N_O+Q+alpha31_w*N_Y+alpha32_w*N_O;
                                            UC_W(4)=(((HP(4)/(1.7+(N_Y+N_O)*0.4))^hp8)/hp8)        +alpha21_w*N_Y+alpha22_w*N_O+Q+alpha31_w*N_Y+alpha32_w*N_O;
                        
                                            if t == T
                                                %t1 schooling wife - HSG, t2 schooling wife - SC, t3 schooling wife - CG, t4 schooling wife - PC, t5 exp wife
                                                %t6 schooling husband if married - HSD, t7 schooling husband - HSG, t8 Shooling husband - SC, t9 Schooling husband CG, t10 schooling husband- PC
                                                %t11 exp husband if married, t12 martial status, t13 number of children, t14 match quality if married, t15 number of children if married
                                                %t16 previous work state - wife, 
                                                U_W(1)=UC_W(1)+t1_w*HSG+t2_w*SC+t3_w*CG+t4_w*PC+t5_w*K+t13_w*(N_Y+N_O);     
                                                U_W(2)=UC_W(2)+t1_w*HSG+t2_w*SC+t3_w*CG+t4_w*PC+t5_w*(K+1)+t13_w*(N_Y+N_O)+t16_w;       
                                                U_W(3)=UC_W(3)+t1_w*HSG+t2_w*SC+t3_w*CG+t4_w*PC+t5_w*K+t6_w*H_HSD+t7_w*H_HSG+t8_w*H_SC+t9_w*H_CG+t10_w*H_PC+t11_w*(HE+D+1)+t12_w+t13_w*(N_Y+N_O)+t14_w*Q+t15_w*(N_Y+N_O);       
                                                U_W(4)=UC_W(4)+t1_w*HSG+t2_w*SC+t3_w*CG+t4_w*PC+t5_w*(K+1)+t6_w*H_HSD+t7_w*H_HSG+t8_w*H_SC+t9_w*H_CG+t10_w*H_PC+t11_w*(HE+D+1)+t12_w+t13_w*(N_Y+N_O)+t14_w*Q+t15_w*(N_Y+N_O)+t16_w;     
                                            else
                                                % EMAX(t,K,N_Y,N_O,prev_state,ability_w_index,M,HE+t,HS,Q_INDEX,ability_h_index, bp)
                                                U_W(1)=UC_W(1)+beta*EMAX_W(t+1,K+1,N_Y+1,N_O+1,0+1,ability_w_index,0+1,1,1,1,1,1);
                                                U_W(2)=UC_W(2)+beta*EMAX_W(t+1,K+2,N_Y+1,N_O+1,1+1,ability_w_index,0+1,1,1,1,1,1);
                                                U_W(3)=UC_W(3)+beta*EMAX_W(t+1,K+1,N_Y+1,N_O+1,0+1,ability_w_index,1+1,(HE+D+1)+1,HS,Q_INDEX,ability_h_index,2);
                                                U_W(4)=UC_W(4)+beta*EMAX_W(t+1,K+2,N_Y+1,N_O+1,1+1,ability_w_index,1+1,(HE+D+1)+1,HS,Q_INDEX,ability_h_index,2);
                                            end
                        
                                            if M == 0  &&  CHOOSE_HUSBAND == 0
                                                U_W(3)  = -99999;
                                                U_W(4)  = -99999;
                                            end
                                            if CHOOSE_WORK == 0
                                                U_W(2) = -99999;
                                                U_W(4) = -99999;
                                            end
                                            % husband CURRENT utility from four options
                                            % U_H(S)=HP(S)+alpha1+alpha21*N_Y+alpha22*N_O+alpha3*M*Q+alpha41*M*N_Y+alpha42*M*N_O;       
                                            UC_H(1)= -99999;
                                            UC_H(2)=((wage_h^hp8)/hp8);
                                            UC_H(3)=(((HP(3)/(1.7+(N_Y+N_O)*0.4))^hp8)/hp8)       +alpha21_h*N_Y+alpha22_h*N_O+M*Q;
                                            UC_H(4)=(((HP(4)/(1.7+(N_Y+N_O)*0.4))^hp8)/hp8)       +alpha21_h*N_Y+alpha22_h*N_O+M*Q;
                                            if t == T
                                                %t1 schooling wife - HSG, t2 schooling wife - SC, t3 schooling wife - CG, t4 schooling wife - PC, t5 exp wife
                                                %t6 schooling husband if married - HSD, t7 schooling husband - HSG, t8 Shooling husband - SC, t9 Schooling husband CG, t10 schooling husband- PC
                                                %t11 exp husband if married, t12 martial status, t13 number of children, t14 match quality if married, t15 number of children if married
                                                %t16 previous work state - wife, t17 previous work state - husband
                                                U_H(1)= -99999; 
                                                U_H(2)=UC_H(2)+t6_h*H_HSD+t7_h*H_HSG+t8_h*H_SC+t9_h*H_CG+t10_h*H_PC+t11_h*(HE+D+1);     
                                                U_H(3)=UC_H(3)+t1_h*HSG+t2_h*SC+t3_h*CG+t4_h*PC+t5_h*K+t6_h*H_HSD+t7_h*H_HSG+t8_h*H_SC+t9_h*H_CG+t10_h*H_PC+t11_h*(HE+D+1)+t12_h+t13_h*(N_Y+N_O)+t14_h*Q;       
                                                U_H(4)=UC_H(4)+t1_h*HSG+t2_h*SC+t3_h*CG+t4_h*PC+t5_h*(K+1)+t6_h*H_HSD+t7_h*H_HSG+t8_h*H_SC+t9_h*H_CG+t10_h*H_PC+t11_h*(HE+D+1)+t12_h+t13_h*(N_Y+N_O)+t14_h*Q+t16_h;     
                                            else
                                                % EMAX(t,K,N_Y,N_O,prev_state,ability_w_index,M,HE+t,HS,Q_INDEX, ability_h_index, bp)
                                                U_H(1)= -99999;
                                                U_H(2)=UC_H(2)+beta*EMAX_H(t+1,1,1,1,1,1,1,(HE+D+1)+1,HS,1,ability_h_index,1);
                                                U_H(3)=UC_H(3)+beta*EMAX_H(t+1,K+1,N_Y+1,N_O+1,0+1,ability_w_index,1+1,(HE+D+1)+1,HS,Q_INDEX,ability_h_index,2);
                                                U_H(4)=UC_H(4)+beta*EMAX_H(t+1,K+2,N_Y+1,N_O+1,1+1,ability_w_index,1+1,(HE+D+1)+1,HS,Q_INDEX,ability_h_index,2);
                                            end
                                            if M == 0  &&  CHOOSE_HUSBAND == 0
                                                U_H(3)  = -99999;
                                                U_H(4)  = -99999;
                                            end
                                            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                                            %   MAXIMIZATION - MARRIAGE + WORK DESICION                        %
                                            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                                            % need optimization - not efficient programing      
                                            % marriage decision - outside option value wife
                                            if U_W(1)>U_W(2)
                                                outside_option_w_v = U_W(1);
                                                %outside_option_w = 1; %"unemployed"
                                            else        
                                                outside_option_w_v = U_W(2);
                                                %outside_option_w = 2; %employed
                                            end
                                            if U_W(3)> outside_option_w_v && U_W(4)> outside_option_w_v 
                                                if U_H(3)>U_H(2) && U_H(4)>U_H(2) %WILL GET MARRIE AND CHOOSE MAX
                                                %%%%%%%%%%%%%%  Nash bergaining at first period of marriage  %%%%%%%%%%%%%%%%%%%%%%%%%%
                                                    nash_value_3 =(U_W(3)-outside_option_w_v)*(U_H(3)-U_H(2)) ;  %value if married and women unemployed
                                                    nash_value_4 =(U_W(4)-outside_option_w_v)*(U_H(4)-U_H(2))  ; %value if married and women unemployed
                                                    if (nash_value_3>nash_value_4)
                                                        M = 1 ;
                                                        emp = 0;
                                                    elseif (nash_value_4>nash_value_3)
                                                        M = 1 ;
                                                        emp = 1;
                                                    end 
                                                elseif U_H(3)>U_H(2) && U_H(4)<U_H(2) %WILL GET MARRIE AND NOT WORK - CHOOSE 3
                                                    M = 1 ;
                                                    emp = 0;
                                                elseif U_H(4)>U_H(2) && U_H(3)<U_H(2) %WILL GET MARRIE AND WORK - CHOOSE 4
                                                    M = 1 ;
                                                    emp = 1;
                                                elseif U_H(3)<U_H(2) && U_H(4)<U_H(2) %WILL NOT GET MARRIE 
                                                    M = 0 ;
                                                    if U_W(1) == outside_option_w_v      %WILL NOT WORK AND SINGLE, CHOOSE 1
                                                        emp = 0;
                                                    else                                %WILL WORK AND SINGLE, CHOOSE 2
                                                        emp = 1;
                                                    end
                                                end
                                            elseif  U_W(3)> outside_option_w_v && U_W(4)< outside_option_w_v %WILL NOT WORK IF MARRIED
                                                if U_H(3)>U_H(2)  %WILL GET MARIED, WILL NOT WORK, CHOOSE 3
                                                    M = 1 ;
                                                    emp = 0;
                                                elseif U_H(3)<U_H(2) %WILL NOT GET MARIED
                                                    M = 0 ;
                                                    if U_W(1) == outside_option_w_v  %WILL NOT WORK AND SINGLE, CHOOSE 1
                                                        emp = 0;
                                                    else                           % WILL WORK AS SINGLE, CHOOSE 2
                                                        emp = 1;
                                                    end
                                                end 
                                            elseif  U_W(4)> outside_option_w_v && U_W(3)< outside_option_w_v %WILL WORK IF MARRIED 
                                                if U_H(4)>U_H(2) %WILL GET MARIED, WILL WORK, CHOOSE 4
                                                    M = 1 ;
                                                    emp = 1;
                                                elseif U_H(4)<U_H(2)  %WILL NOT GET MARIED
                                                    M = 0 ;
                                                    if U_W(1) == outside_option_w_v %WILL NOT WORK AND SINGLE, CHOOSE 1 
                                                        emp = 0;
                                                    else                          % WILL WORK AS SINGLE, CHOOSE 2
                                                        emp = 1;
                                                    end
                                                end 
                                            elseif  U_W(4)< outside_option_w_v && U_W(3)< outside_option_w_v % WILL NOT MARRIED
                                                M = 0 ;
                                                if U_W(1) == outside_option_w_v %WILL NOT WORK AND SINGLE, CHOOSE 1
                                                    emp = 0;
                                                else                            % WILL WORK AS SINGLE, CHOOSE 2
                                                    emp = 1;
                                                end
                                            end
                                            if M == 0 && emp == 0
                                                emax_draw_w(draw_b) = U_W(1);
                                            elseif M == 0 && emp == 1
                                                emax_draw_w(draw_b) = U_W(2);
                                            elseif M == 1 && emp == 0
                                                emax_draw_w(draw_b) = U_W(3);
                                            elseif M == 1 && emp == 1
                                                emax_draw_w(draw_b) = U_W(4);   
                                            end
                                        end % close draw_b loop 
                                        % emax is the average of emax_draw over the draws
                                        emax_w = mean(emax_draw_w);
                                        % EMAX(t,K,N_Y,N_O,prev_state,ability_w_index,M,HE+t,HS,Q_INDEX, ability_h_index, bp)
                                        EMAX_W(t,K+1,N_Y+1,N_O+1,prev_state+1,ability_w_index,0+1,1,1,1,1,2) = emax_w;%EMAX of a single women

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   EMAX FOR MARRIED MEN AND WOMEN      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                                    elseif M_T_minus_1 == 1
                                        for HS = 1:5 %husband schooling :HSD,HSG,SC, CG, PC
                                            for Q_INDEX = 1:5 % Match Quality 
                                                Q = normal_arr(Q_INDEX)*sigma(5,5);
                                                if t<21
												    for H_EXP = 0:t %HUSBAND EXPERENCE
                                                        for ability_h_index = 1:5   %husband ability
                                                            ability_h = normal_arr(ability_h_index)*sigma(4,4);
                                                            for  bp_dummy = 1 :3   % 0.25, 0.5, 0.75 - bp from previous period
                                                                for draw_b = 1 : DRAW_B
                                                                    % CURRENT HUSBAND WAGE 
                                                                    H_HSD = 0; H_HSG = 0; H_SC = 0; H_CG = 0; H_PC = 0;
                                                                    if HS == 1
                                                                        H_HSD = 1;
                                                                    elseif HS == 2
                                                                        H_HSG = 1;
                                                                    elseif HS == 3
                                                                        H_SC = 1;
                                                                    elseif HS == 4
                                                                        H_CG = 1;
                                                                    elseif HS == 5
                                                                        H_PC = 1;
                                                                    end     
                                                                    tmp1_h = ability_h + beta1_h*(H_EXP)+ beta2_h*(H_EXP).^2+ beta30_h*H_HSD+beta31_h*H_HSG+ beta32_h*H_SC+ beta33_h*H_CG+ beta34_h*H_PC;
                                                                    tmp2_h = (epsilon_b(draw_b, t,school_group,1)*sigma(1,1)); %epsilon_b(draw_b, t, sex)
                                                                    wage_h = exp(tmp1_h + tmp2_h);
                                                                    % JOB OFFER PROBABILITY + WAGE WIFE
                                                                    %w_draws = rand(DRAW_F,T,2); 1 -job offer, 2-new child, 
                                                                    PROB_TMP=row0*prev_state + row11*HSG +row12*SC +row13*CG +row14*PC + row2*K;
                                                                    PROB_W= exp(PROB_TMP) ./ (1+exp(PROB_TMP));
                                                                    if PROB_W > w_draws_b(draw_b,t,school_group,5)
                                                                        CHOOSE_WORK = 1;
                                                                        tmp1_w = ability_w + beta1_w*K + beta2_w*K.^2 + beta31_w*HSG+beta32_w*SC+ beta33_w*CG+ beta34_w*PC;
                                                                        tmp2_w = (epsilon_b(draw_b, t, school_group,2)*sigma(2,2)); %epsilon_b(draw_b, t, sex)  
                                                                        wage_w = exp(tmp1_w + tmp2_w);
                                                                    else
                                                                        CHOOSE_WORK = 0;
                                                                        wage_w = 0;
                                                                    end
                                                                    % decision making - choose from up to 4 options, according to CHOOSE_HUSBAND and CHOOSE_WORK values
                                                                    % utility from each option:
                                                                    % home production - equal for both partners:  1-singe+unemployed
                                                                    %                                             2-singe+employed
                                                                    %                                             3-married+unemployed
                                                                    %                                             4-married+eployed
                                                                    %home production technology - parameters    
                                                                    %   HP(S)=((1+hp1*N_Y+hp2*N_O)*(hp3+hp4)^hp7+(1+hp5*N_Y+hp6*N_O)*(wage_w+wage_h)^hp7)^(1/hp7);
                                                                    HP(1)=((1+hp1*N_Y+hp2*N_O)*(hp4)^hp7+(1+hp5*N_Y+hp6*N_O)*(0)^hp7)^(1/hp7);
                                                                    HP(2)=((1+hp1*N_Y+hp2*N_O)*(0)^hp7+(1+hp5*N_Y+hp6*N_O)*(wage_w)^hp7)^(1/hp7);%all cancel out but wage_w if no kids
                                                                    HP(3)=((1+hp1*N_Y+hp2*N_O)*(hp4)^hp7+(1+hp5*N_Y+hp6*N_O)*(wage_h)^hp7)^(1/hp7);
                                                                    HP(4)=((1+hp1*N_Y+hp2*N_O)*(0)^hp7+(1+hp5*N_Y+hp6*N_O)*(wage_h+wage_w)^hp7)^(1/hp7);
                                                                    % wife utility from each option
                                                                    % U_W(S)=HP(S)+alpha1+alpha21*N_Y+alpha22*N_O+alpha3*M*Q+alpha41*M*N_Y+alpha42*M*N_O;                   
                                                                    %scale_w = 1 + M*0.7 + (N_Y+N_O)*0.4;
                                                                    UC_W(1)=(((HP(1)/(1+(N_Y+N_O)*0.4))^hp8)/hp8)+alpha1_w+alpha21_w*N_Y+alpha22_w*N_O;
                                                                    UC_W(2)=(((HP(2)/(1+(N_Y+N_O)*0.4))^hp8)/hp8)         +alpha21_w*N_Y+alpha22_w*N_O;
                                                                    UC_W(3)=(((HP(3)/(1.7+(N_Y+N_O)*0.4))^hp8)/hp8)+alpha1_w+alpha21_w*N_Y+alpha22_w*N_O+Q+alpha31_w*N_Y+alpha32_w*N_O;
                                                                    UC_W(4)=(((HP(4)/(1.7+(N_Y+N_O)*0.4))^hp8)/hp8)        +alpha21_w*N_Y+alpha22_w*N_O+Q+alpha31_w*N_Y+alpha32_w*N_O;
                                                                    if t == T
                                                                        U_W(1)=UC_W(1)+t1_w*HSG+t2_w*SC+t3_w*CG+t4_w*PC+t5_w*K+t13_w*(N_Y+N_O);     
                                                                        U_W(2)=UC_W(2)+t1_w*HSG+t2_w*SC+t3_w*CG+t4_w*PC+t5_w*(K+1)+t13_w*(N_Y+N_O)+t16_w;       
                                                                        U_W(3)=UC_W(3)+t1_w*HSG+t2_w*SC+t3_w*CG+t4_w*PC+t5_w*K+t6_w*H_HSD+t7_w*H_HSG+t8_w*H_SC+t9_w*H_CG+t10_w*H_PC+t11_w*(H_EXP+1)+t12_w+t13_w*(N_Y+N_O)+t14_w*Q+t15_w*(N_Y+N_O);      
                                                                        U_W(4)=UC_W(4)+t1_w*HSG+t2_w*SC+t3_w*CG+t4_w*PC+t5_w*(K+1)+t6_w*H_HSD+t7_w*H_HSG+t8_w*H_SC+t9_w*H_CG+t10_w*H_PC+t11_w*(H_EXP+1)+t12_w+t13_w*(N_Y+N_O)+t14_w*Q+t15_w*(N_Y+N_O)+t16_w;        
                                                                    else
                                                                        % EMAX(t,K,N_Y,N_O,prev_state,ability_w_index,M,HE+t,HS,Q_INDEX,ability_h_index, bp)
                                                                        U_W(1)=UC_W(1)+beta*EMAX_W(t+1,K+1,N_Y+1,N_O+1,0+1,ability_w_index,0+1,1,1,1,1,1);
                                                                        U_W(2)=UC_W(2)+beta*EMAX_W(t+1,K+2,N_Y+1,N_O+1,1+1,ability_w_index,0+1,1,1,1,1,1);
                                                                        U_W(3)=UC_W(3)+beta*EMAX_W(t+1,K+1,N_Y+1,N_O+1,0+1,ability_w_index,1+1,(H_EXP+1)+1,HS,Q_INDEX,ability_h_index,bp_dummy);
                                                                        U_W(4)=UC_W(4)+beta*EMAX_W(t+1,K+2,N_Y+1,N_O+1,1+1,ability_w_index,1+1,(H_EXP+1)+1,HS,Q_INDEX,ability_h_index,bp_dummy);
                                                                    end
                                                                    if CHOOSE_WORK == 0
                                                                        U_W(2) = -99999;
                                                                        U_W(4) = -99999;
                                                                    end
                                                                    % husband CURRENT utility from four options
                                                                    % U_H(S)=HP(S)+alpha1+alpha21*N_Y+alpha22*N_O+alpha3*M*Q+alpha41*M*N_Y+alpha42*M*N_O;       
                                                                    UC_H(1)= -99999;
                                                                    UC_H(2)=((wage_h^hp8)/hp8);
                                                                    UC_H(3)=(((HP(3)/(1.7+(N_Y+N_O)*0.4))^hp8)/hp8)       +alpha21_h*N_Y+alpha22_h*N_O+M*Q;
                                                                    UC_H(4)=(((HP(4)/(1.7+(N_Y+N_O)*0.4))^hp8)/hp8)       +alpha21_h*N_Y+alpha22_h*N_O+M*Q;
                                                                    if t == T
                                                                        U_H(1)= -99999; 
                                                                        U_H(2)=UC_H(2)+t6_h*H_HSD+t7_h*H_HSG+t8_h*H_SC+t9_h*H_CG+t10_h*H_PC+t11_h*(H_EXP+1);        
                                                                        U_H(3)=UC_H(3)+t1_h*HSG+t2_h*SC+t3_h*CG+t4_h*PC+t5_h*K+t6_h*H_HSD+t7_h*H_HSG+t8_h*H_SC+t9_h*H_CG+t10_h*H_PC+t11_h*(H_EXP+1)+t12_h+t13_h*(N_Y+N_O)+t14_h*Q;      
                                                                        U_H(4)=UC_H(4)+t1_h*HSG+t2_h*SC+t3_h*CG+t4_h*PC+t5_h*(K+1)+t6_h*H_HSD+t7_h*H_HSG+t8_h*H_SC+t9_h*H_CG+t10_h*H_PC+t11_h*(H_EXP+1)+t12_h+t13_h*(N_Y+N_O)+t14_h*Q+t16_h;        
                                                                    else
                                                                        % EMAX(t,K,N_Y,N_O,prev_state,ability_w_index,M,HE+t,HS,Q_INDEX, ability_h_index, bp)
                                                                        U_H(1)= -99999;
                                                                        U_H(2)=UC_H(2)+beta*EMAX_H(t+1,1,1,1,1,1,1,(H_EXP+1)+1,HS,1,ability_h_index,1);
                                                                        U_H(3)=UC_H(3)+beta*EMAX_H(t+1,K+1,N_Y+1,N_O+1,0+1,ability_w_index,1+1,(H_EXP+1)+1,HS,Q_INDEX,ability_h_index,bp_dummy);
                                                                        U_H(4)=UC_H(4)+beta*EMAX_H(t+1,K+2,N_Y+1,N_O+1,1+1,ability_w_index,1+1,(H_EXP+1)+1,HS,Q_INDEX,ability_h_index,bp_dummy);
                                                                    end
                                                                    if CHOOSE_WORK == 0
                                                                        U_H(4) = -99999;
                                                                    end
                                                                    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                                                                    %   MAXIMIZATION - MARRIAGE + WORK DESICION                        %
                                                                    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                                                                    % need optimization - not efficient programing      
                                                                    % marriage decision - outside option value wife
                                                                    if U_W(1)>U_W(2)
                                                                        outside_option_w_v = U_W(1);
                                                                        %outside_option_w = 1; %"unemployed"
                                                                    else        
                                                                        outside_option_w_v = U_W(2);
                                                                        %outside_option_w = 2; %employed
                                                                    end
                                                                    if U_W(3)> outside_option_w_v && U_W(4)> outside_option_w_v 
                                                                        if U_H(3)>U_H(2) && U_H(4)>U_H(2) %WILL GET MARRIE AND CHOOSE MAX
                                                                        %they are already married, both want to stay married, need to choose 3 or 4 according to bp
																		    if bp_dummy ==1
																			    bp = 0.25;
																		    elseif bp_dummy ==2
																			    bp = 0.5;
																		    else
																			    bp = 0.75;
																		    end	
																		    if bp*U_H(3)+(1-bp)*U_W(3)>bp*U_H(4)+(1-bp)*U_W(4)  %WILL GET MARRIE AND NOT WORK - CHOOSE 3
																			    M = 1 ;
																			    emp = 0;
																		    else                  %WILL GET MARRIE AND WORK - CHOOSE 4
																			    M = 1 ;
																			    emp = 1;
																		    end                                                                      
                                                                        elseif U_H(3)>U_H(2) && U_H(4)<U_H(2) %WILL GET MARRIE AND NOT WORK - CHOOSE 3
                                                                            M = 1 ;
                                                                            emp = 0;
                                                                        elseif U_H(4)>U_H(2) && U_H(3)<U_H(2) %WILL GET MARRIE AND WORK - CHOOSE 4
                                                                            M = 1 ;
                                                                            emp = 1;
                                                                        elseif U_H(3)<U_H(2) && U_H(4)<U_H(2) %WILL NOT GET MARRIE 
                                                                            M = 0 ;
                                                                            if U_W(1) == outside_option_w_v      %WILL NOT WORK AND SINGLE, CHOOSE 1
                                                                                emp = 0;
                                                                            else                                %WILL WORK AND SINGLE, CHOOSE 2
                                                                                emp = 1;
                                                                            end
                                                                        end
                                                                    elseif  U_W(3)> outside_option_w_v && U_W(4)< outside_option_w_v %WILL NOT WORK IF MARRIED
                                                                        if U_H(3)>U_H(2)  %WILL GET MARIED, WILL NOT WORK, CHOOSE 3
                                                                            M = 1 ;
                                                                            emp = 0;
                                                                        elseif U_H(3)<U_H(2) %WILL NOT GET MARIED
                                                                            M = 0 ;
                                                                            if U_W(1) == outside_option_w_v  %WILL NOT WORK AND SINGLE, CHOOSE 1
                                                                                emp = 0;
                                                                            else                           % WILL WORK AS SINGLE, CHOOSE 2
                                                                                emp = 1;
                                                                            end
                                                                        end 
                                                                    elseif  U_W(4)> outside_option_w_v && U_W(3)< outside_option_w_v %WILL WORK IF MARRIED 
                                                                        if U_H(4)>U_H(2) %WILL GET MARIED, WILL WORK, CHOOSE 4
                                                                            M = 1 ;
                                                                            emp = 1;
                                                                        elseif U_H(4)<U_H(2)  %WILL NOT GET MARIED
                                                                            M = 0 ;
                                                                            if U_W(1) == outside_option_w_v %WILL NOT WORK AND SINGLE, CHOOSE 1 
                                                                                emp = 0;
                                                                            else                          % WILL WORK AS SINGLE, CHOOSE 2
                                                                                emp = 1;
                                                                            end
                                                                        end 
                                                                    elseif  U_W(4)< outside_option_w_v && U_W(3)< outside_option_w_v % WILL NOT MARRIED
                                                                        M = 0 ;
                                                                        if U_W(1) == outside_option_w_v %WILL NOT WORK AND SINGLE, CHOOSE 1
                                                                            emp = 0;
                                                                        else                            % WILL WORK AS SINGLE, CHOOSE 2
                                                                            emp = 1;
                                                                        end
                                                                    end
                                                                    if M == 0 && emp == 0
                                                                        emax_draw_h(draw_b) = U_H(2); %if no marriage, give husband the value of unmarriage - only one option - U_H(2)
                                                                        emax_draw_w(draw_b) = U_W(1);
                                                                    elseif M == 0 && emp == 1
                                                                        emax_draw_h(draw_b) = U_H(2); %if no marriage, give husband the value of unmarriage - only one option - U_H(2)
                                                                        emax_draw_w(draw_b) = U_W(2);
                                                                    elseif M == 1 && emp == 0
                                                                        emax_draw_h(draw_b) = U_H(3);
                                                                        emax_draw_w(draw_b) = U_W(3);
                                                                    elseif M == 1 && emp == 1
                                                                        emax_draw_h(draw_b) = U_H(4);
                                                                        emax_draw_w(draw_b) = U_W(4);   
                                                                    end
                                                                end % close draw_b loop 
                                                                % emax is the average of emax_draw over the draws
                                                                emax_h = mean(emax_draw_h);
                                                                emax_w = mean(emax_draw_h);
                                                                % EMAX(t,K,N_Y,N_O,prev_state,ability_w_index,M,HE+t,HS,Q_INDEX, ability_h_index, bp)
                                                                EMAX_H(t,K+1,N_Y+1,N_O+1,prev_state+1, ability_w_index,1+1,(H_EXP+1),HS,Q_INDEX,ability_h_index, bp_dummy) = emax_h;
                                                                EMAX_W(t,K+1,N_Y+1,N_O+1,prev_state+1, ability_w_index,1+1,(H_EXP+1),HS,Q_INDEX,ability_h_index, bp_dummy) = emax_w;
                                                            end  % close bp_dummy loop
                                                        end % close husband bility
                                                    end % close husband experience
												end % close if t<21
                                            end % close the match quality loop
                                        end %close the husband schooling loop
                                    end % close the if T_minus_1 = =
                                end %close the  marriage loop
                            end % close the exp loop
                        end % wife abiity
                    end % prev state
                end % close the old children loop
            end % close the young children loop
        end %close the if school_group>1 in line 639!!!!!!!!!!!!!!!!!!!!!!!!!
    end % close the time loop
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%% SOLVING FORWARD %%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Initialize state
    if school_group > 1  % do not run all the rest of the EMAX for HSD women
        H_HSD = 0; H_HSG = 0; H_SC = 0; H_CG = 0; H_PC = 0;   %update the schooling since it was distroyed in the single men EMAX
        if school_group == 2
            HSD = 0; HSG = 1;  SC = 0;  CG = 0; PC = 0;
        elseif school_group == 3    
            HSD = 0; HSG = 0;  SC = 1;  CG = 0; PC = 0;
        elseif school_group == 4
            HSD = 0; HSG = 0;  SC = 0; CG = 1; PC = 0;
        else
            HSD = 0; HSG = 0;  SC = 0;  CG = 0;     PC = 1;
        end
    % repeat forward times to generalize the result of a specific sample
        for draw_f = 1 : DRAW_F
            K=0;
            if draw_f < DRAW_F./2
                prev_state = 0;
            else
                prev_state = 1;
            end 
            prev_state_T_minus_1 = 0;
            count_age1 = 0; %the age of the oldest child under6
            count_age2 = 0; %the age of the 2nd oldest child under6
            count_age3 = 0; %the age of the 3rd oldest child under6
            count_age4 = 0; %the age of the 3rd oldest child under6
            count_age5 = 0; %the age of the 3rd oldest child under6
            year_married = 0;
            M=0 ;
            M_T_minus_1=0;
            NEW_BORN = 0;
            N_Y = 0;
            N_O = 0;
            N_TOTAL = 0;
            N_TOTAL_M = 0;
            N_TOTAL_UM = 0;
            D = 0 ;
            D_T_minus_1 = 0;
            Q = 0;
            HS = 1;
            HE = 0;
            bp = 0.5;
			bp_dummy = 2;
            %w_ability_draw = rand(DRAW_F);
            ability_w = normal_arr(w_ability_draw(draw_f, school_group))*sigma(3,3);
            ability_w_index = w_ability_draw(draw_f,school_group);
            % Make choices for all periods
            for t = 1 : T
                % husbands cohort characteristics
                %   P_HUSBAND=husbands(t,1);
                P_HSD_0=husbands(t+age_index,2);
                P_HSD_5=husbands(t+age_index,3);
                P_HSD_10=husbands(t+age_index,4);
                P_HSD_20=husbands(t+age_index,5);
                P_HSG_0=husbands(t+age_index,6);
                P_HSG_5=husbands(t+age_index,7);
                P_HSG_10=husbands(t+age_index,8);
                P_HSG_20=husbands(t+age_index,9);
                P_SC_0=husbands(t+age_index,10);
                P_SC_5=husbands(t+age_index,11);
                P_SC_10=husbands(t+age_index,12);
                P_SC_20=husbands(t+age_index,13);
                P_CG_0=husbands(t+age_index,14);
                P_CG_5=husbands(t+age_index,15);
                P_CG_10=husbands(t+age_index,16);
                P_CG_20=husbands(t+age_index,17);
                P_PC_0=husbands(t+age_index,18);
                P_PC_5=husbands(t+age_index,19);
                P_PC_10=husbands(t+age_index,20);
                P_PC_20=husbands(t+age_index,21);
                %h_draws = rand(DRAW_F,T,5); %1- HUSBAND; 2-HUSBAND EXP+SCHOOLING; 3-HUSBAND ABILITY; 4 - INITIAL MATCH QUALITY; 5 - MATCH UALITY CHANGE PROBABILITY
                % DRAW A POTENTIAL HUSBAND: EXP, SCHOOLING, MATCH QUALITY, ABILITY
                
                prev_state_T_minus_1 = prev_state;
                D_T_minus_1 = D;
                NEW_BORN = 0;
                if M == 0
                    D = 0;
                    Q = 0;
                    if h_draws(draw_f,t,school_group,1)<P_HUSBAND
                        CHOOSE_HUSBAND = 1;
                        ability_h = normal_arr(h_draws(draw_f,t,school_group,3))*sigma(4,4);
                        ability_h_index = h_draws(draw_f,t,school_group,3);
                        Q = normal_arr(h_draws(draw_f,t,school_group,4))*sigma(5,5);
                        Q_INDEX = h_draws(draw_f,t,school_group,4);
                        H_HSD = 0; H_HSG = 0; H_SC = 0; H_CG = 0; H_PC = 0;  
                        if h_draws(draw_f,t,school_group,2)<P_HSD_0%husband schooling HSD
                            HS = 1;
                            H_HSD=1;
                            HE = HE0;
                        elseif (h_draws(draw_f,t,school_group,2)>P_HSD_0 && h_draws(draw_f,t,school_group,2)<P_HSD_5)
                             HS = 1;
                            H_HSD=1;
                            HE = HE5;
                        elseif (h_draws(draw_f,t,school_group,2)>P_HSD_5 && h_draws(draw_f,t,school_group,2)<P_HSD_10)
                             HS = 1;
                            H_HSD=1;
                            HE = HE10;
                        elseif (h_draws(draw_f,t,school_group,2)>P_HSD_10 && h_draws(draw_f,t,school_group,2)<P_HSD_20)
                             HS = 1;
                            H_HSD=1;
                            HE = HE20;    
                        elseif (h_draws(draw_f,t,school_group,2)>P_HSD_20 && h_draws(draw_f,t,school_group,2)<P_HSG_0) %husband schooling HSG
                             HS = 2;
                            H_HSG=1;
                            HE = HE0; 
                        elseif h_draws(draw_f,t,school_group,2)>P_HSG_0 && h_draws(draw_f,t,school_group,2)<P_HSG_5
                             HS = 2;
                            H_HSG=1;
                            HE = HE5; 
                        elseif h_draws(draw_f,t,school_group,2)>P_HSG_5 && h_draws(draw_f,t,school_group,2)<P_HSG_10
                             HS = 2;
                            H_HSG=1;
                            HE = HE10;    
                        elseif h_draws(draw_f,t,school_group,2)>P_HSG_10 && h_draws(draw_f,t,school_group,2)<P_HSG_20
                             HS = 2;
                            H_HSG=1;
                            HE = HE20;    
                        elseif h_draws(draw_f,t,school_group,2)>P_HSG_20 && h_draws(draw_f,t,school_group,2)<P_SC_0  %husband schooling SC
                             HS = 3;
                            H_SC=1;
                            HE = HE0; 
                        elseif h_draws(draw_f,t,school_group,2)>P_SC_0 && h_draws(draw_f,t,school_group,2)<P_SC_5
                             HS = 3;
                            H_SC=1;
                            HE = HE5; 
                        elseif h_draws(draw_f,t,school_group,2)>P_SC_5 && h_draws(draw_f,t,school_group,2)<P_SC_10
                             HS = 3;
                            H_SC=1;
                            HE = HE10;    
                        elseif h_draws(draw_f,t,school_group,2)>P_SC_10 && h_draws(draw_f,t,school_group,2)<P_SC_20
                             HS = 3;
                            H_SC = 1;
                            HE = HE20;    
                        elseif h_draws(draw_f,t,school_group,2)>P_SC_20 && h_draws(draw_f,t,school_group,2)<P_CG_0  %husband schooling CG
                             HS = 4;
                            H_CG=1;
                            HE = HE0; 
                        elseif h_draws(draw_f,t,school_group,2)>P_CG_0 && h_draws(draw_f,t,school_group,2)<P_CG_5
                             HS = 4;
                            H_CG=1;
                            HE = HE5; 
                        elseif h_draws(draw_f,t,school_group,2)>P_CG_5 && h_draws(draw_f,t,school_group,2)<P_CG_10
                             HS = 4;
                            H_CG=1;
                            HE = HE10;    
                        elseif h_draws(draw_f,t,school_group,2)>P_CG_10 && h_draws(draw_f,t,school_group,2)<P_CG_20
                             HS = 4;
                            H_CG = 1;
                            HE = HE20;                    
                        elseif h_draws(draw_f,t,school_group,2)>P_CG_20 && h_draws(draw_f,t,school_group,2)<P_PC_0  %husband schooling PC
                             HS = 5;
                            H_PC=1;
                            HE = HE0; 
                        elseif h_draws(draw_f,t,school_group,2)>P_PC_0 && h_draws(draw_f,t,school_group,2)<P_PC_5
                             HS = 5;
                            H_PC=1;
                            HE = HE5; 
                        elseif h_draws(draw_f,t,school_group,2)>P_PC_5 && h_draws(draw_f,t,school_group,2)<P_PC_10
                             HS = 5;
                            H_PC=1;
                            HE = HE10;    
                        elseif h_draws(draw_f,t,school_group,2)>P_PC_10 && h_draws(draw_f,t,school_group,2)<P_PC_20
                             HS = 5;
                            H_PC = 1;
                            HE = HE20;    
                        end
                        if HS == 1
                            H_HSD = 1;
                        elseif HS == 2
                            H_HSG = 1;
                        elseif HS == 3
                            H_SC = 1;
                        elseif HS == 4
                            H_CG = 1;
                        elseif HS == 5
                            H_PC = 1;
                        end         
                    else
                        CHOOSE_HUSBAND = 0;
                    end 
                end     
                if HE+D>20
					HE_D = 20
				else
					HE_D = HE+D
				end	
				% POTENTIAL OR CURRENT HUSBAND WAGE:
                if (M == 1 ||  CHOOSE_HUSBAND == 1)
                    tmp1_h = ability_h + beta1_h*(HE_D)+ beta2_h*(HE_D).^2+ beta30_h*H_HSD+beta31_h*H_HSG+ beta32_h*H_SC+ beta33_h*H_CG+ beta34_h*H_PC;
                    tmp2_h = (epsilon_f(draw_f, t,school_group,1)*sigma(1,1)); %epsilon_f(draw_f, t, sex)
                    wage_h = exp(tmp1_h + tmp2_h);
                else
                    wage_h = 0;
                end 
                % JOB OFFER PROBABILITY + WAGE WIFE
                %w_draws = rand(DRAW_F,T,2); 1 -job offer, 2-new child, 
                PROB_TMP=row0*prev_state + row11*HSG +row12*SC +row13*CG +row14*PC + row2*K;
                PROB_W= exp(PROB_TMP) ./ (1+exp(PROB_TMP));
                if PROB_W > w_draws(draw_f,t,school_group,1)
                    CHOOSE_WORK = 1;
                    tmp1_w = ability_w + beta1_w*K + beta2_w*K.^2 + beta31_w*HSG+beta32_w*SC+ beta33_w*CG+ beta34_w*PC;
                    tmp2_w = (epsilon_f(draw_f, t, school_group,2)*sigma(2,2)); %epsilon_f(draw_f, t, sex)  
                    wage_w = exp(tmp1_w + tmp2_w);
                else
                    CHOOSE_WORK = 0;
                    wage_w = 0;
                end
                % decision making - choose from up to 4 options, according to CHOOSE_HUSBAND and CHOOSE_WORK values
                % utility from each option:
                % home production - equal for both partners:     1-singe+unemployed
                                                    %            2-singe+employed
                                                    %            3-married+unemployed
                                                    %            4-married+eployed
                %home production technology - parameters    
                %   hp1 - # of young children influence on work at home hours
                %   hp2 - # of old children influence on work at home hours
                %   hp3 - husband leisure - always working so zero
                %   hp4 - wife leisure
                %   hp5 - # of young children influence on consumption  
                %   hp6 - # of old children infl
                %   HP(S)=((1+hp1*N_Y+hp2*N_O)*(hp3+hp4)^hp7+(1+hp5*N_Y+hp6*N_O)*(wage_w+wage_h)^hp7)^(1/hp7);
                HP(1)=((1+hp1*N_Y+hp2*N_O)*(hp4)^hp7+(1+hp5*N_Y+hp6*N_O)*(0)^hp7)^(1/hp7);
                HP(2)=((1+hp1*N_Y+hp2*N_O)*(0)^hp7+(1+hp5*N_Y+hp6*N_O)*(wage_w)^hp7)^(1/hp7);%all cancel out but wage_w if no kids
                HP(3)=((1+hp1*N_Y+hp2*N_O)*(hp4)^hp7+(1+hp5*N_Y+hp6*N_O)*(wage_h)^hp7)^(1/hp7);
                HP(4)=((1+hp1*N_Y+hp2*N_O)*(0)^hp7+(1+hp5*N_Y+hp6*N_O)*(wage_h+wage_w)^hp7)^(1/hp7);
                % wife utility from each option
                % U_W(S)=HP(S)+alpha1+alpha21*N_Y+alpha22*N_O+alpha3*M*Q+alpha41*M*N_Y+alpha42*M*N_O;                   
                %scale_w = 1 + M*0.7 + (N_Y+N_O)*0.4;
                UC_W(1)=(((HP(1)/(1+(N_Y+N_O)*0.4))^hp8)/hp8)+alpha1_w+alpha21_w*N_Y+alpha22_w*N_O;
                UC_W(2)=(((HP(2)/(1+(N_Y+N_O)*0.4))^hp8)/hp8)         +alpha21_w*N_Y+alpha22_w*N_O;
                UC_W(3)=(((HP(3)/(1.7+(N_Y+N_O)*0.4))^hp8)/hp8)+alpha1_w+alpha21_w*N_Y+alpha22_w*N_O+Q+alpha31_w*N_Y+alpha32_w*N_O;
                UC_W(4)=(((HP(4)/(1.7+(N_Y+N_O)*0.4))^hp8)/hp8)        +alpha21_w*N_Y+alpha22_w*N_O+Q+alpha31_w*N_Y+alpha32_w*N_O;
                
                if t == T
                    %t1 schooling wife - HSG, t2 schooling wife - SC, t3 schooling wife - CG, t4 schooling wife - PC, t5 exp wife
                    %t6 schooling husband if married - HSD, t7 schooling husband - HSG, t8 Shooling husband - SC, t9 Schooling husband CG, t10 schooling husband- PC
                    %t11 exp husband if married, t12 martial status, t13 number of children, t14 match quality if married, t15 number of children if married
                    %t16 previous work state - wife, 
                    U_W(1)=UC_W(1)+t1_w*HSG+t2_w*SC+t3_w*CG+t4_w*PC+t5_w*K+t13_w*(N_Y+N_O);     
                    U_W(2)=UC_W(2)+t1_w*HSG+t2_w*SC+t3_w*CG+t4_w*PC+t5_w*(K+1)+t13_w*(N_Y+N_O)+t16_w;       
                    U_W(3)=UC_W(3)+t1_w*HSG+t2_w*SC+t3_w*CG+t4_w*PC+t5_w*K+t6_w*H_HSD+t7_w*H_HSG+t8_w*H_SC+t9_w*H_CG+t10_w*H_PC+t11_w*(HE_D+1)+t12_w+t13_w*(N_Y+N_O)+t14_w*Q+t15_w*(N_Y+N_O);       
                    U_W(4)=UC_W(4)+t1_w*HSG+t2_w*SC+t3_w*CG+t4_w*PC+t5_w*(K+1)+t6_w*H_HSD+t7_w*H_HSG+t8_w*H_SC+t9_w*H_CG+t10_w*H_PC+t11_w*(HE_D+1)+t12_w+t13_w*(N_Y+N_O)+t14_w*Q+t15_w*(N_Y+N_O)+t16_w;     
                else
                    % EMAX(t,K,N_Y,N_O,prev_state,ability_w_index,M,HE+t,HS,Q_INDEX, ability_h_index)
                    U_W(1)=UC_W(1)+beta*EMAX_W(t+1,K+1,N_Y+1,N_O+1,0+1,ability_w_index,0+1,0+1,0+1,0+1,0+1,0+1);
                    U_W(2)=UC_W(2)+beta*EMAX_W(t+1,K+2,N_Y+1,N_O+1,1+1,ability_w_index,0+1,0+1,0+1,0+1,0+1,0+1);
                    U_W(3)=UC_W(3)+beta*EMAX_W(t+1,K+1,N_Y+1,N_O+1,0+1,ability_w_index,1+1,(HE_D+1)+1,HS,Q_INDEX,ability_h_index,bp_dummy);
                    U_W(4)=UC_W(4)+beta*EMAX_W(t+1,K+2,N_Y+1,N_O+1,1+1,ability_w_index,1+1,(HE_D+1)+1,HS,Q_INDEX,ability_h_index,bp_dummy);
                end
                
                if M == 0  &&  CHOOSE_HUSBAND == 0
                    U_W(3)  = -99999;
                    U_W(4)  = -99999;
                end
                if CHOOSE_WORK == 0
                    U_W(2) = -99999;
                    U_W(4) = -99999;
                    
                end
                % husband CURRENT utility from four options
                % U_H(S)=HP(S)+alpha1+alpha21*N_Y+alpha22*N_O+alpha3*M*Q+alpha41*M*N_Y+alpha42*M*N_O;       
                UC_H(1)= -99999;
                UC_H(2)=((wage_h^hp8)/hp8);
                UC_H(3)=(((HP(3)/(1.7+(N_Y+N_O)*0.4))^hp8)/hp8)       +alpha21_h*N_Y+alpha22_h*N_O+M*Q;
                UC_H(4)=(((HP(4)/(1.7+(N_Y+N_O)*0.4))^hp8)/hp8)       +alpha21_h*N_Y+alpha22_h*N_O+M*Q;
                if t == T
                    %t1 schooling wife - HSG, t2 schooling wife - SC, t3 schooling wife - CG, t4 schooling wife - PC, t5 exp wife
                    %t6 schooling husband if married - HSD, t7 schooling husband - HSG, t8 Shooling husband - SC, t9 Schooling husband CG, t10 schooling husband- PC
                    %t11 exp husband if married, t12 martial status, t13 number of children, t14 match quality if married, t15 number of children if married
                    %t16 previous work state - wife, t17 previous work state - husband
                    U_H(1)= -99999; 
                    U_H(2)=UC_H(2)+t6_h*H_HSD+t7_h*H_HSG+t8_h*H_SC+t9_h*H_CG+t10_h*H_PC+t11_h*(HE_D+1);     
                    U_H(3)=UC_H(3)+t1_h*HSG+t2_h*SC+t3_h*CG+t4_h*PC+t5_h*K+t6_h*H_HSD+t7_h*H_HSG+t8_h*H_SC+t9_h*H_CG+t10_h*H_PC+t11_h*(HE_D+1)+1+t12_h+t13_h*(N_Y+N_O)+t14_h*Q;       
                    U_H(4)=UC_H(4)+t1_h*HSG+t2_h*SC+t3_h*CG+t4_h*PC+t5_h*(K+1)+t6_h*H_HSD+t7_h*H_HSG+t8_h*H_SC+t9_h*H_CG+t10_h*H_PC+t11_h*(HE_D+1)+1+t12_h+t13_h*(N_Y+N_O)+t14_h*Q+t16_h;     
                else
                    % EMAX(t,K,N_Y,N_O,prev_state,ability_w_index,M,HE+t,HS,Q_INDEX, ability_h_index)
                    U_H(1)= -99999;
                    U_H(2)=UC_H(2)+beta*EMAX_H(t+1,1,1,1,1,1,1,HE_D+1,HS,1,ability_h_index,1);
                    U_H(3)=UC_H(3)+beta*EMAX_H(t+1,K+1,N_Y+1,N_O+1,0+1,ability_w_index,1+1,(HE_D+1)+1,HS,Q_INDEX,ability_h_index,bp_dummy);
                    U_H(4)=UC_H(4)+beta*EMAX_H(t+1,K+2,N_Y+1,N_O+1,1+1,ability_w_index,1+1,(HE_D+1)+1,HS,Q_INDEX,ability_h_index,bp_dummy);
                end
                if M == 0  &&  CHOOSE_HUSBAND == 0
                    U_H(3)  = -99999;
                    U_H(4)  = -99999;
                end
                if CHOOSE_WORK == 0
                    U_H(4) = -99999;
                end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %   MAXIMIZATION - MARRIAGE + WORK DESICION                        %
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                % need optimization - not efficient programing      
                M_T_minus_1 = M;
                % marriage decision - outside option value wife
                if U_W(1)>U_W(2)
                    outside_option_w_v = U_W(1);
                    %outside_option_w = 1; %"unemployed"
                else        
                    outside_option_w_v = U_W(2);
                    %outside_option_w = 2; %employed
                end
                if U_W(3)> outside_option_w_v && U_W(4)> outside_option_w_v 
                    if U_H(3)>U_H(2) && U_H(4)>U_H(2) %WILL GET MARRIE AND CHOOSE MAX
                        %%%%%%%%%%%%%%  Nash bergaining at first period of marriage  %%%%%%%%%%%%%%%%%%%%%%%%%%
                        if  M_T_minus_1 == 0 
                            nash_value_3 =(U_W(3)-outside_option_w_v)*(U_H(3)-U_H(2)) ;  %value if married and women unemployed
                            nash_value_4 =(U_W(4)-outside_option_w_v)*(U_H(4)-U_H(2))  ; %value if married and women unemployed
                            if (nash_value_3>nash_value_4)
                                M = 1 ;
                                prev_state = 0;
                                emp_choice(draw_f,t,school_group) = 0;
                                marriage_choice(draw_f,t,school_group) = 1;
                                %%%%%   find the value of alpha - the bargaining power %%%%%%
                                if 0.5*U_H(3)+0.5*U_W(3)>0.5*U_H(4)+0.5*U_W(4)
                                    bp = 0.5;
								else %need to change the value of alpha - the bargaining power so 3-married+unemployed will be better than 4-married+employed
                                    option_3_values=bp_vector*U_H(3)+(1-bp_vector)*U_W(3);   %a 11 elements vector, with the weighted utility by BP for option 3
                                    option_4_values=bp_vector*U_H(4)+(1-bp_vector)*U_W(4);  %a 11 elements vector, with the weighted utility by BP for option 4
                                    posibilities=option_3_values>option_4_values  ;     %a 11 elements vector, with 1 for all the alpha-bp where 3 is bigger than 4, all possible alphas
                                    option_3_values_possibles=option_3_values.*posibilities;    %a 11 elements vector, with the utility values only for the relevent bp
                                    ind1 = find(option_3_values_possibles(1:11), 1, 'first');
                                    ind2 = find(option_3_values_possibles(1:11), 1, 'last');
                                    if abs(6-ind1)>abs(6-ind2)
                                        bp=(ind2-1)*0.1;
                                    else
                                        bp=(ind1-1)*0.1;    
                                    end
                                end 
                            elseif (nash_value_4>nash_value_3)
                                M = 1 ;
                                prev_state = 1;
                                K = K + 1;
                                emp_choice(draw_f,t,school_group) = 1;
                                marriage_choice(draw_f,t,school_group) = 1;
                                %%%%%   find the value of alpha - the bargaining power %%%%%%
                                if 0.5*U_H(4)+0.5*U_W(4)>0.5*U_H(3)+0.5*U_W(3) 
                                    bp = 0.5;  
                                else %need to change the value of alpha - the bargaining power so 4-married+employed will be better than 3-married+unemployed
                                    option_3_values=bp_vector*U_H(3)+(1-bp_vector)*U_W(3);   %a 11 elements vector, with the weighted utility by BP for option 3
                                    option_4_values=bp_vector*U_H(4)+(1-bp_vector)*U_W(4);  %a 11 elements vector, with the weighted utility by BP for option 4
                                    posibilities=option_4_values>option_3_values ;      %a 11 elements vector, with 1 for all the alpha-bp where 3 is bigger than 4, all possible alphas
                                    option_4_values_possibles=option_4_values.*posibilities ;   %a 11 elements vector, with the utility values only for the relevent bp
                                    ind1 = find(option_4_values_possibles(1:6), 1, 'last');
                                    ind2 = find(option_4_values_possibles(6:11), 1, 'first');
                                    ind2 = 5 +  ind2;
                                    if (6-ind1)<(ind2-6)
                                        bp=(ind1-1)*0.1;
                                    else
                                        bp=(ind2-1)*0.1 ;
                                    end
                                end 
                            end 
                        else %they are already married, both want to stay married, need to choose 3 or 4 according to bp
                            if bp*U_H(3)+(1-bp)*U_W(3)>bp*U_H(4)+(1-bp)*U_W(4)  %WILL GET MARRIE AND NOT WORK - CHOOSE 3
                                M = 1 ;
                                prev_state = 0;
                                emp_choice(draw_f,t,school_group) = 0;
                                marriage_choice(draw_f,t,school_group) = 1;
                            else                                                %WILL GET MARRIE AND WORK - CHOOSE 4
                                M = 1 ;
                                prev_state = 1;
                                K = K + 1;
                                emp_choice(draw_f,t,school_group) = 1;
                                marriage_choice(draw_f,t,school_group) = 1;
                            end 
                        end %close just married if - calculate bp
                    elseif U_H(3)>U_H(2) && U_H(4)<U_H(2) %WILL GET MARRIE AND NOT WORK - CHOOSE 3
                        M = 1 ;
                        prev_state = 0;
                        emp_choice(draw_f,t,school_group) = 0;
                        marriage_choice(draw_f,t,school_group) = 1;
                        % update bargaining power if needed
                        if bp*U_H(3)+(1-bp)*U_W(3)<bp*U_H(4)+(1-bp)*U_W(4) && U_W(4) > -99990;%if under the current bp, they prefare 4 and not 3, need to change bp
                            option_3_values=bp_vector*U_H(3)+(1-bp_vector)*U_W(3);   %a 11 elements vector, with the weighted utility by BP for option 3
                            option_4_values=bp_vector*U_H(4)+(1-bp_vector)*U_W(4);  %a 11 elements vector, with the weighted utility by BP for option 4
                            posibilities=option_3_values>option_4_values ;      %a 11 elements vector, with 1 for all the alpha-bp where 3 is bigger than 4, all possible alphas
                            option_3_values_possibles=option_3_values.*posibilities ;   %a 11 elements vector, with the utility values only for the relevent bp
                            ind1 = find(option_3_values_possibles(1:11), 1, 'first');
                            ind2 = find(option_3_values_possibles(1:11), 1, 'last');
                            if abs((bp*10+1)-ind1)>abs((bp*10+1)-ind2)
                                bp=(ind2-1)*0.1;
                            else
                                bp=(ind1-1)*0.1 ;
                            end
                        end
                        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    elseif U_H(4)>U_H(2) && U_H(3)<U_H(2) %WILL GET MARRIE AND WORK - CHOOSE 4
                        M = 1 ;
                        prev_state = 1;
                        K = K + 1;
                        emp_choice(draw_f,t,school_group) = 1;
                        marriage_choice(draw_f,t,school_group) = 1;
                        % update bargaining power if needed
                        if bp*U_H(4)+(1-bp)*U_W(4)<bp*U_H(3)+(1-bp)*U_W(3) && U_W(4) > -99990 %if under the current bp, they prefare 3 and not 4, need to change bp
                            option_3_values=bp_vector*U_H(3)+(1-bp_vector)*U_W(3);   %a 11 elements vector, with the weighted utility by BP for option 3
                            option_4_values=bp_vector*U_H(4)+(1-bp_vector)*U_W(4);  %a 11 elements vector, with the weighted utility by BP for option 4
                            posibilities=option_4_values>option_3_values ;      %a 11 elements vector, with 1 for all the alpha-bp where 3 is bigger than 4, all possible alphas
                            option_4_values_possibles=option_4_values.*posibilities ;   %a 11 elements vector, with the utility values only for the relevent bp
                            ind1 = find(option_4_values_possibles(1:11), 1, 'first');
                            ind2 = find(option_4_values_possibles(1:11), 1, 'last');
                            if abs((bp*10+1)-ind1)>abs((bp*10+1)-ind2)
                                bp=(ind2-1)*0.1;
                            else
                                bp=(ind1-1)*0.1 ;
                            end
                        end
                        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    elseif U_H(3)<U_H(2) && U_H(4)<U_H(2) %WILL NOT GET MARRIE 
                        M = 0 ;
                        marriage_choice(draw_f,t,school_group) = 0;
                        if U_W(1) == outside_option_w_v      %WILL NOT WORK AND SINGLE, CHOOSE 1
                            prev_state = 0;
                            emp_choice(draw_f,t,school_group) = 0;
                        else                                %WILL WORK AND SINGLE, CHOOSE 2
                            prev_state = 1;
                            K = K + 1;
                            emp_choice(draw_f,t,school_group) = 1;
                        end
                    end
                elseif  U_W(3)> outside_option_w_v && U_W(4)< outside_option_w_v %WILL NOT WORK IF MARRIED
                    if U_H(3)>U_H(2)  %WILL GET MARIED, WILL NOT WORK, CHOOSE 3
                        M = 1 ;
                        prev_state = 0;
                        emp_choice(draw_f,t,school_group) = 0;
                        marriage_choice(draw_f,t,school_group) = 1;
                        % update bargaining power if needed
                        if bp*U_H(3)+(1-bp)*U_W(3)<bp*U_H(4)+(1-bp)*U_W(4) && U_W(4) > -99990%if under the current bp, they prefare 4 and not 3, need to change bp
                            option_3_values=bp_vector*U_H(3)+(1-bp_vector)*U_W(3);   %a 11 elements vector, with the weighted utility by BP for option 3
                            option_4_values=bp_vector*U_H(4)+(1-bp_vector)*U_W(4);  %a 11 elements vector, with the weighted utility by BP for option 4
                            posibilities=option_3_values>option_4_values ;      %a 11 elements vector, with 1 for all the alpha-bp where 3 is bigger than 4, all possible alphas
                            option_3_values_possibles=option_3_values.*posibilities ;   %a 11 elements vector, with the utility values only for the relevent bp
                            ind1 = find(option_3_values_possibles(1:11), 1, 'first');
                            ind2 = find(option_3_values_possibles(1:11), 1, 'last');
                            if abs((bp*10+1)-ind1)>abs((bp*10+1)-ind2)
                                bp=(ind2-1)*0.1;
                            else
                                bp=(ind1-1)*0.1 ;
                            end
                        end
                        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    elseif U_H(3)<U_H(2) %WILL NOT GET MARIED
                        M = 0 ;
                        marriage_choice(draw_f,t,school_group) = 0;
                        if U_W(1) == outside_option_w_v  %WILL NOT WORK AND SINGLE, CHOOSE 1
                            prev_state = 0;
                            emp_choice(draw_f,t,school_group) = 0;
                        else                           % WILL WORK AS SINGLE, CHOOSE 2
                            prev_state = 1;
                            K = K + 1;
                            emp_choice(draw_f,t,school_group) = 1;
                        end
                    end 
                elseif  U_W(4)> outside_option_w_v && U_W(3)< outside_option_w_v %WILL WORK IF MARRIED 
                    if U_H(4)>U_H(2) %WILL GET MARIED, WILL WORK, CHOOSE 4
                        M = 1 ;
                        prev_state = 1;
                        K = K + 1;
                        emp_choice(draw_f,t,school_group) = 1;
                        marriage_choice(draw_f,t,school_group) = 1;
                        % update bargaining power if needed
                        if bp*U_H(4)+(1-bp)*U_W(4)<bp*U_H(3)+(1-bp)*U_W(3) && U_W(4) > -99990%if under the current bp, they prefare 3 and not 4, need to change bp
                            option_3_values=bp_vector*U_H(3)+(1-bp_vector)*U_W(3);   %a 11 elements vector, with the weighted utility by BP for option 3
                            option_4_values=bp_vector*U_H(4)+(1-bp_vector)*U_W(4);  %a 11 elements vector, with the weighted utility by BP for option 4
                            posibilities=option_4_values>option_3_values ;      %a 11 elements vector, with 1 for all the alpha-bp where 3 is bigger than 4, all possible alphas
                            option_4_values_possibles=option_4_values.*posibilities ;   %a 11 elements vector, with the utility values only for the relevent bp
                            ind1 = find(option_4_values_possibles(1:11), 1, 'first');
                            ind2 = find(option_4_values_possibles(1:11), 1, 'last');
                            if abs((bp*10+1)-ind1)>abs((bp*10+1)-ind2)
                                bp=(ind2-1)*0.1;
                            else
                                bp=(ind1-1)*0.1 ;
                            end
                        end
                        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    elseif U_H(4)<U_H(2)  %WILL NOT GET MARIED
                        M = 0 ;
                        marriage_choice(draw_f,t,school_group) = 0;
                        if U_W(1) == outside_option_w_v %WILL NOT WORK AND SINGLE, CHOOSE 1 
                            prev_state = 0;
                            emp_choice(draw_f,t,school_group) = 0;
                        else                          % WILL WORK AS SINGLE, CHOOSE 2
                            prev_state = 1;
                            K = K + 1;
                            emp_choice(draw_f,t,school_group) = 1;
                        end
                    end 
                elseif  U_W(4)< outside_option_w_v && U_W(3)< outside_option_w_v % WILL NOT MARRIED
                    M = 0 ;
                    marriage_choice(draw_f,t,school_group) = 0;
                    if U_W(1) == outside_option_w_v %WILL NOT WORK AND SINGLE, CHOOSE 1
                        prev_state = 0;
                        emp_choice(draw_f,t,school_group) = 0;
                    else                            % WILL WORK AS SINGLE, CHOOSE 2
                        prev_state = 1;
                        K = K + 1;
                        emp_choice(draw_f,t,school_group) = 1;
                    end
                end
                
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%      
        %         FERTILITY EXOGENOUS PROCESS - check for another child + update age of children %
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%      
                %probability of another child parameters:
                                %c1 previous work state - wife
                                %c2 age wife - HSG
                                %c3 age square  wife - HSG
                                %c4 age wife - SC
                                %c5 age square  wife - SC
                                %c6 age wife - CG
                                %c7 age square  wife - CG
                                %c8 age wife - PC
                                %c9 age square  wife - PC
                                %c10 number of children at household    
                                %c11 schooling - husband
                                %c12 unmarried
                c_lamda=c1*prev_state+c2*HSG*(AGE+t)+c3*HSG*(AGE+t)^2+c4*SC*(AGE+t)+c5*SC*(AGE+t)^2+c6*CG*(AGE+t)+c7*CG*(AGE+t)^2+c8*PC*(AGE+t)+c9*PC*(AGE+t)^2+c10*(N_Y+N_O)+c11*HS*M+c12*M;
                child_prob = normcdf(c_lamda);
                if (w_draws(draw_f,t,school_group,2) < child_prob) && ((AGE+t) < 40 ) %w_draws = rand(DRAW_F,T,3); 1-job offer, 2-new child, 3 - match quality change- new child was born
                    NEW_BORN = 1;
                    N_Y = N_Y + 1;
                    N_TOTAL = N_TOTAL + 1;
                    if M == 1
                        N_TOTAL_M = N_TOTAL_M +1;
                    else
                        N_TOTAL_UM = N_TOTAL_UM +1;
                    end 
                    if N_Y==1
                        count_age1=1;
                    elseif N_Y==2   
                        count_age2=1;
                    elseif N_Y==3
                        count_age3=1;
                    elseif N_Y==4
                        count_age4=1;
                    elseif N_Y==5
                        count_age5=1;   
                    end 
                elseif N_Y > 0
                    if  count_age1==5 %no new born, just update ages - 5 years old chid
                        count_age1=count_age2;
                        count_age2=count_age3;
                        count_age3=count_age4;
                        count_age4=count_age5;
                        count_age5=0;
                        N_Y=N_Y-1;
                        if N_O<4
                            N_O=N_O+1;
                        end
                    end         
                    count_age1=count_age1+1;
                    if count_age2>0
                        count_age2=count_age2+1;
                    end 
                    if count_age3>0
                        count_age3=count_age3+1;
                    end 
                    if count_age4>0
                        count_age4=count_age4+1;
                    end 
                    if count_age5>0
                        count_age5=count_age5+1;
                    end 
                end 
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %  UPDARE T+1 STATE SPACE
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                
                % EMAX(t,K,N_Y,N_O,prev_state,ability_w_index,M,HE+D,HS,Q_INDEX, ability_h_index)
        % t - by loop
        % K - updated in  MAXIMIZATION - MARRIAGE + WORK DESICION
        % N_Y, N_O, count_age1-4 - updated in   FERTILITY EXOGENOUS PROCESS
        % prev_state -  updated in  MAXIMIZATION - MARRIAGE + WORK DESICION
        % abiity_w, ability_h_index, HE, HS - constants
        % M - updated in  MAXIMIZATION - MARRIAGE + WORK DESICION
        % DURATION + MATCH QUALITY
                if (M == 1)
                    D = D + 1;
                    MATCH_QUALITY_CHANGE_PROBABIITY = h_draws(draw_f,t,school_group,5);
                    if (MATCH_QUALITY_CHANGE_PROBABIITY < MATCH_Q_DECREASE && Q_INDEX > 1)
                        Q_INDEX = Q_INDEX - 1;
                        Q = normal_arr(Q_INDEX)*sigma(5,5);
                    elseif (MATCH_QUALITY_CHANGE_PROBABIITY > MATCH_Q_DECREASE) && (MATCH_QUALITY_CHANGE_PROBABIITY < MATCH_Q_DECREASE + MATCH_Q_INCREASE) && (Q_INDEX < 5)
                        Q_INDEX = Q_INDEX + 1;
                        Q = normal_arr(Q_INDEX)*sigma(5,5);
                    end
                end
				if bp>0.5
					bp_dummy = 3;
				elseif bp < 0.5
					bp_dummy = 1;
				else
					bp_dummy = 2;
				end	
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                %   CREATE AND SAVE MOMENTS
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                %individual moments:
                emp(draw_f, t+age_index, school_group)= prev_state;         % employment total - prev_state is actually current state at this point
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                %                   MARRIED WOMEN EMPLOYMENT BY KIDS INDIVIDUAL MOMENTS
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                if N_TOTAL == 0 && M ==1 
                    emp_m_no_kids(draw_f, t+age_index , school_group) = prev_state;         % employment married no kids
                    count_emp_m_no_kids(t+age_index,school_group)=count_emp_m_no_kids(t+age_index,school_group)+1;
                elseif N_TOTAL == 1 && M ==1
                    emp_m_one_kid(draw_f, t+age_index, school_group) = prev_state;          % employment married 1 kid
                    count_emp_m_one_kid(t+age_index,school_group) = count_emp_m_one_kid(t+age_index,school_group)+1;
                elseif N_TOTAL > 1 && N_TOTAL < 4 && M ==1  
                    emp_m_2_3_kids(draw_f, t+age_index, school_group) = prev_state;         % employment married 2-3 kids
                    count_emp_m_2_3_kids(t+age_index,school_group) =count_emp_m_2_3_kids(t+age_index,school_group)+1; 
                elseif N_TOTAL > 3  && M ==1
                    emp_m_4plus_kids(draw_f, t+age_index, school_group) = prev_state;           % employment married 4  kids
                    count_emp_m_4plus_kids(t+age_index,school_group) = count_emp_m_4plus_kids(t+age_index,school_group)+1;
                end
                if N_Y == 0 && M ==1 
                    emp_m_no_y_kids(draw_f, t+age_index , school_group) = prev_state;           % employment married no kids
                    count_emp_m_no_y_kids(t+age_index,school_group)=count_emp_m_no_y_kids(t+age_index,school_group)+1;
                elseif N_Y == 1 && M ==1
                    emp_m_one_y_kid(draw_f, t+age_index, school_group) = prev_state;            % employment married 1 kid
                    count_emp_m_one_y_kid(t+age_index,school_group) = count_emp_m_one_y_kid(t+age_index,school_group)+1;
                elseif N_Y > 1 && N_Y < 4 && M ==1  
                    emp_m_2_3_y_kids(draw_f, t+age_index, school_group) = prev_state;           % employment married 2-3 kids
                    count_emp_m_2_3_y_kids(t+age_index,school_group) =count_emp_m_2_3_y_kids(t+age_index,school_group)+1; 
                elseif N_Y > 3  && M ==1
                    emp_m_4plus_y_kids(draw_f, t+age_index, school_group) = prev_state;         % employment married 4  kids
                    count_emp_m_4plus_y_kids(t+age_index,school_group) = count_emp_m_4plus_y_kids(t+age_index,school_group)+1;
                end
                if N_O == 0 && M ==1
                    emp_m_no_o_kids(draw_f, t+age_index, school_group) = prev_state;            % employment married no kids
                    count_emp_m_no_o_kids(t+age_index,school_group)=count_emp_m_no_o_kids(t+age_index,school_group)+1;
                elseif N_O == 1 && M ==1
                    emp_m_one_o_kid(draw_f, t+age_index, school_group) = prev_state;            % employment married 1 kid
                    count_emp_m_one_o_kid(t+age_index,school_group) = count_emp_m_one_o_kid(t+age_index,school_group)+1;
                elseif N_O > 1 && N_O < 4 & M ==1
                    emp_m_2_3_o_kids(draw_f, t+age_index, school_group) = prev_state;           % employment married 2-3 kids
                    count_emp_m_2_3_o_kids(t+age_index,school_group) = count_emp_m_2_3_o_kids(t+age_index,school_group)+1;
                elseif N_O > 3  && M ==1 
                    emp_m_4plus_o_kids(draw_f, t+age_index, school_group) = prev_state;         % employment married 4  kids
                    count_emp_m_4plus_o_kids(t+age_index, school_group) = count_emp_m_4plus_o_kids(t+age_index, school_group) +1;
                end


                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                %                   UNMARRIED WOMEN EMPLOYMENT BY KIDS INDIVIDUAL MOMENTS                       %
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                if M == 0;
                    emp_um(draw_f, t+age_index, school_group) = prev_state;         % employment unmarried
                    if (N_Y+N_O)==0
                        emp_um_no_kids(draw_f, t+age_index, school_group) = prev_state;     % employment unmarried and no children
                        count_emp_um_no_kids(t+age_index, school_group) = count_emp_um_no_kids(t+age_index, school_group) + 1;
                    else
                        emp_um_kids(draw_f, t+age_index, school_group) = prev_state;            % employment unmarried and children
                        count_emp_um_kids(t+age_index, school_group) = count_emp_um_kids(t+age_index, school_group) + 1;
                    end 
                end
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                %                 EMPLOYMENT TRANSITION MATRIX                                                 %
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                if prev_state == 1 && prev_state_T_minus_1 == 0
                    just_found_job(draw_f, t+age_index, school_group) = 1;              % for transition matrix - unemployment to employment 
                elseif prev_state == 0 && prev_state_T_minus_1 == 1
                    just_got_fired(draw_f, t+age_index, school_group)= 1;               % for transition matrix - employment to unemployment
                end
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                %                   MARRIED WOMEN EMPLOYMENT + WAGES MOMENTS
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                if prev_state == 1
                    wages_w(draw_f, K, school_group)=wage_w;        % women wages if employed by experience
                end 
                if M == 1 
                    wages_m_h(draw_f, HE+D, HS)=wage_h;         % married men wages
                    emp_m(draw_f, t+age_index, school_group) = prev_state;      % employment married women  
                    if school_group > HS                %women married down, men married up - HS is 1 to 5 while school_group 1 to 4 so to copare: -1
                        emp_m_down(draw_f, t+age_index, school_group) = prev_state;         % employment married down
                        count_emp_m_down(t+age_index, school_group) = count_emp_m_down(t+age_index, school_group)+1;
                        wages_m_h_up(draw_f, HE+D, HS)=wage_h;   % married up men wages 
                        count_wages_m_h_up(HE+D, HS)=count_wages_m_h_up(HE+D, HS)+1;
                    elseif school_group < HS            %women married up, men married down
                        emp_m_up(draw_f, t+age_index, school_group) = prev_state;   % employment married up women
                        count_emp_m_up(t+age_index, school_group) = count_emp_m_up(t+age_index, school_group)+1;
                        wages_m_h_down(draw_f, HE+D, HS)=wage_h; % married down men wages
                        count_wages_m_h_down(HE+D, HS)=count_wages_m_h_down(HE+D, HS)+1;
                    elseif  school_group == HS         %married equal
                        wages_m_h_eq(draw_f, HE+D, HS)=wage_h;   % married equal men wages 
                        count_wages_m_h_eq(HE+D, HS)=count_wages_m_h_eq(HE+D, HS)+1;
                        emp_m_eq(draw_f, t+age_index, school_group) = prev_state;   % employment married equal women
                        count_emp_m_eq(t+age_index, school_group) = count_emp_m_eq(t+age_index, school_group)+1;
                    end
                end
                if M==1 && prev_state == 1                              %prev_state is actually current state at this point
                    wages_m_w(draw_f, K, school_group)=wage_w;          % married women wages if employed
                    if school_group < HS
                        wages_m_w_up(draw_f, K, school_group)=wage_w;   % married up women wages if employed
                        count_wages_m_w_up(K, school_group)=count_wages_m_w_up(K, school_group)+1;
                    elseif school_group > HS
                        wages_m_w_down(draw_f, K, school_group)=wage_w; % married down women wages if employed
                        count_wages_m_w_down(K, school_group)=count_wages_m_w_down(K, school_group)+1;
                    elseif school_group == HS
                        wages_m_w_eq(draw_f, K, school_group)=wage_w; % married equal women wages if employed
                        count_wages_m_w_eq(K, school_group)=count_wages_m_w_eq(K, school_group)+1;
                    end
                elseif M==0 && prev_state == 1
                    wages_um_w(draw_f, K, school_group)=wage_w;         % unmarried women wages if employed
                end
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                %           FERTILITY AND MARRIED RATE MOMENTS
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                married(draw_f, t+age_index, school_group) = M  ;                   % married yes/no
                newborn(draw_f, t+age_index, school_group)=NEW_BORN;                % new born in period t - for probability and distribution

                %duration_of_first_marriage(draw_f, school_group) = D_T_minus_1 ;
                if t == T 
                    kids(draw_f, school_group) = N_TOTAL ;          % # of children by school group
                    kids_m(draw_f, school_group) = N_TOTAL_M;
                    kids_um(draw_f, school_group) = N_TOTAL_UM;
                end
                if M==1 && M_T_minus_1==0
                    just_married(draw_f, t+age_index, school_group)=1;          % for transition matrix from single to married
                    if age_at_first_marriage(draw_f, school_group)==0
                        age_at_first_marriage(draw_f, school_group)=AGE+t;
                        assortative_mating(draw_f, school_group) = HS;
                    end 
                elseif (M==0 && M_T_minus_1==1)
                    just_divorced(draw_f, t+age_index, school_group)=1;         % for transition matrix from married to divorce
                    %if duration_of_first_marriage(draw_f, school_group)==0
                %   Q
                %   M
                %   D
                %   M_T_minus_1
                %   D_T_minus_1
                        duration_of_first_marriage(draw_f, school_group) = D_T_minus_1 ;                % duration of marriage if divorce 
                        count_duration_of_first_marriage(school_group) = count_duration_of_first_marriage(school_group)+1;
                    %end
                end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%           END MOMENTS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            end % close the time loop
        end % close the draw_f loop
    end  % close the if school_group>0 at line 1146
end % close the schooling_group loop
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%            CLOSE SOLVING FORWARD           %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% RESULTS SUMMARY - CREATES MOMENTS IN THE SAME FORMAT AS ACTUAL MOMENTS FOR OBJECTIVE SGMM FUNCTION %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%emp_moments - 13 by 28 matrix - 
%first column - age
%column 2-5 - employment rate by education group. start at t+age index
%column 6-9 - married women employment rate by education group. start at t+age index
%column 10-13- unmarried women employment rate by education group. start at t+age index
f_emp = [mean(emp(:,:,2)); mean(emp(:,:,3)); mean(emp(:,:,4)); mean(emp(:,:,5))]' ;                                 % employment total by education
tmp_married = [sum(married(:,:,2)); sum(married(:,:,3)); sum(married(:,:,4)); sum(married(:,:,5))]';                % married yes/no
f_emp_m = [sum(emp_m(:,:,2)); sum(emp_m(:,:,3)); sum(emp_m(:,:,4)); sum(emp_m(:,:,5))]';                            % employment married by education
f_emp_m  = f_emp_m ./tmp_married
f_emp_um = [sum(emp_um(:,:,2)); sum(emp_um(:,:,3)); sum(emp_um(:,:,4)); sum(emp_um(:,:,5))]';                       % employment unmarried by education
f_emp_um  = f_emp_um ./[DRAW_F - tmp_married]
%marr_fer_moments - 9 by 28 matrix
%first column - age
%column 2-5 - marriage rate by education group. start at t+age index
%column 6-9 - frtility rate by education group - start at t+age index end at 42
f_married = [mean(married(:,:,2)); mean(married(:,:,3)); mean(married(:,:,4)); mean(married(:,:,5))]'   
f_fertility = [mean(newborn(:,:,2)); mean(newborn(:,:,3)); mean(newborn(:,:,4)); mean(newborn(:,:,5))]';    
%wage_moments - 10 by 36 matrix
%first column - potential or real experience
%column 2-5 - annual wage for women by education group - run until 27 for HSG, 25 for SC, 23 for CG and 20 for PC.
%column 6-10 - annual wage for men by education group - run until initial exp+t == 35
ind_tmp=(wages_m_h>0);    % married men wages
tmp = wages_m_h.*ind_tmp;
f_wages_m_h = [sum(tmp(1:36,:,1))./sum(ind_tmp(1:36,:,1)); sum(tmp(1:36,:,2))./sum(ind_tmp(1:36,:,2)); sum(tmp(1:36,:,3))./sum(ind_tmp(1:36,:,3)); sum(tmp(1:36,:,4))./sum(ind_tmp(1:36,:,4)); sum(tmp(1:36,:,5))./sum(ind_tmp(1:36,:,5))]'
ind_tmp=(wages_w>0);    % women wages
tmp = wages_w.*ind_tmp;
f_wages_w = [sum(tmp(:,:,2))./sum(ind_tmp(:,:,2)); sum(tmp(:,:,3))./sum(ind_tmp(:,:,3)); sum(tmp(:,:,4))./sum(ind_tmp(:,:,4)); sum(tmp(:,:,5))./sum(ind_tmp(:,:,5))]'
%general_moments - 4 by 27 matrix
%by education group:
%assortative mating - H_HSD %assortative mating - H_HSG %assortative mating - H_SC  %assortative mating - H_CG  %assortative mating - H_PC
%marriage_duration  %age at first marriage  %total # of kids by 40
%women wage by match - UP   %women wage by match - EQUAL    %women wage by match - DOWN 
%men wage by match - UP %men wage by match - EQUAL  %men wage by match - DOWN
%employment by match - UP   %employment by match - EQUAL    %employment by match - DOWN
%emp by children for married : NO KIDS  %  1 KIDS   2 KIDS %emp by TOTAL children for married -  3 KIDS %emp by TOTAL children for married -  4 KIDS
%emp by children for unmarried -  KIDS %emp by children for unmarried - NO KIDS
down=(assortative_mating(:,2)<2);
sum_down = sum(down);
equal=(assortative_mating(:,2)==2);
sum_equal = sum(equal);
up=(assortative_mating(:,2)>2);
sum_up = sum(up);
sum_all=sum_down+sum_equal+sum_up;
f_assortative_mating1 = [sum_down/sum_all sum_equal/sum_all sum_up/sum_all];

down=(assortative_mating(:,3)<3);
sum_down = sum(down);
equal=(assortative_mating(:,3)==3);
sum_equal = sum(equal);
up=(assortative_mating(:,3)>3);
sum_up = sum(up);
sum_all=sum_down+sum_equal+sum_up;
f_assortative_mating2 = [sum_down/sum_all sum_equal/sum_all sum_up/sum_all];

down=(assortative_mating(:,4)<4);
sum_down = sum(down);
equal=(assortative_mating(:,4)==4);
sum_equal = sum(equal);
up=(assortative_mating(:,4)>4);
sum_up = sum(up);
sum_all=sum_down+sum_equal+sum_up;
f_assortative_mating3 = [sum_down/sum_all sum_equal/sum_all sum_up/sum_all];

down=(assortative_mating(:,5)<5);
sum_down = sum(down);
equal=(assortative_mating(:,5)==5);
sum_equal = sum(equal);
sum_all=sum_down+sum_equal;
f_assortative_mating4 = [sum_down/sum_all sum_equal/sum_all 0];

f_assortative_mating = [f_assortative_mating1' f_assortative_mating2' f_assortative_mating3' f_assortative_mating4']
f_duration =[mean(nonzeros(duration_of_first_marriage(:,2))); mean(nonzeros(duration_of_first_marriage(:,3))); mean(nonzeros(duration_of_first_marriage(:,4))); mean(nonzeros(duration_of_first_marriage(:,5)))]'   % duration of marriage if divorce 
f_age_at_first_marriage =[mean(nonzeros(age_at_first_marriage(:,2))); mean(nonzeros(age_at_first_marriage(:,3))); mean(nonzeros(age_at_first_marriage(:,4))); mean(nonzeros(age_at_first_marriage(:,5)))]'   
f_kids = [mean(kids(:,2)) ;     mean(kids(:,3)); mean(kids(:,4)); mean(kids(:,5))]'         % # of children by school group
%f_kids_m = [sum(kids_m(:,1))./(tmp_married(T,1)) ; sum(kids_m(:,2))./(tmp_married(T,2)); sum(kids_m(:,3))./(tmp_married(T,3)); sum(kids_m(:,4))./(tmp_married(T,4))]'          % # of children by school group
%f_kids_um = [sum(kids_um(:,1))./[DRAW_F-(tmp_married(T,1))];   sum(kids_um(:,2))./[DRAW_F-(tmp_married(T,2))]; sum(kids_um(:,3))./[DRAW_F-(tmp_married(T,3))]; sum(kids_um(:,4))./[DRAW_F-(tmp_married(T,4))]]'            % # of children by school group
% f_kids_m +um - not working
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ind_tmp=(wages_m_w_up>0);    % married UP women wages
tmp = wages_m_w_up.*ind_tmp;
f_wages_m_w_up = [sum(tmp(:,:,2)); sum(tmp(:,:,3)); sum(tmp(:,:,4)); sum(tmp(:,:,5)) ]';
f_wages_m_w_up = f_wages_m_w_up./count_wages_m_w_up;
ff_wages_m_w_up = nanmean(f_wages_m_w_up)

ind_tmp=(wages_m_w_eq>0);    % married equal women wages
tmp = wages_m_w_eq.*ind_tmp;
f_wages_m_w_eq = [sum(tmp(:,:,2)); sum(tmp(:,:,3)); sum(tmp(:,:,4)); sum(tmp(:,:,5))]';
f_wages_m_w_eq = f_wages_m_w_eq./count_wages_m_w_eq;
ff_wages_m_w_eq = nanmean(f_wages_m_w_eq)
ind_tmp=(wages_m_w_down>0);    % married DOWN women wages
tmp = wages_m_w_down.*ind_tmp;
f_wages_m_w_down = [sum(tmp(:,:,2)); sum(tmp(:,:,3)); sum(tmp(:,:,4)); sum(tmp(:,:,5))]';
f_wages_m_w_down = f_wages_m_w_down./count_wages_m_w_down;
ff_wages_m_w_down = nanmean(f_wages_m_w_down)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5555
ind_tmp=(wages_m_h_up>0);    % married UP men wages
tmp = wages_m_h_up.*ind_tmp;
f_wages_m_h_up = [sum(tmp(:,:,1)); sum(tmp(:,:,2)); sum(tmp(:,:,3)); sum(tmp(:,:,4)); sum(tmp(:,:,5))]';
f_wages_m_h_up = f_wages_m_h_up./count_wages_m_h_up;
ff_wages_m_h_up = nanmean(f_wages_m_h_up(1:36,:))

ind_tmp=(wages_m_h_eq>0);    % married equal men wages
tmp = wages_m_h_eq.*ind_tmp;
f_wages_m_h_eq = [sum(tmp(:,:,1)); sum(tmp(:,:,2)); sum(tmp(:,:,3)); sum(tmp(:,:,4)); sum(tmp(:,:,5))]';
f_wages_m_h_eq = f_wages_m_h_eq./count_wages_m_h_eq;
ff_wages_m_h_eq = nanmean(f_wages_m_h_eq(1:36,:))
ind_tmp=(wages_m_h_down>0);    % married DOWN men wages
tmp = wages_m_h_down.*ind_tmp;
f_wages_m_h_down = [sum(tmp(:,:,1)); sum(tmp(:,:,2)); sum(tmp(:,:,3)); sum(tmp(:,:,4)); sum(tmp(:,:,5))]';
f_wages_m_h_down = f_wages_m_h_down./count_wages_m_h_down;
ff_wages_m_h_down = nanmean(f_wages_m_h_down(1:36,:))
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
f_emp_m_down = [sum(emp_m_down(:,:,2)); sum(emp_m_down(:,:,3)); sum(emp_m_down(:,:,4)); sum(emp_m_down(:,:,5))]';           % employment married down
f_emp_m_down = f_emp_m_down./count_emp_m_down;
ff_emp_m_down = nanmean(f_emp_m_down)
f_emp_m_eq = [sum(emp_m_eq(:,:,2)); sum(emp_m_eq(:,:,3)); sum(emp_m_eq(:,:,4)); sum(emp_m_eq(:,:,5))]'  ;       % employment married equal
f_emp_m_eq = f_emp_m_eq./count_emp_m_eq;
ff_emp_m_eq = nanmean(f_emp_m_eq)
f_emp_m_up = [sum(emp_m_up(:,:,2)); sum(emp_m_up(:,:,3)); sum(emp_m_up(:,:,4)); sum(emp_m_up(:,:,5))]';         % employment married up
f_emp_m_up = f_emp_m_up./count_emp_m_up;
ff_emp_m_up = nanmean(f_emp_m_up)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                   MARRIED WOMEN EMPLOYMENT BY KIDS AVERAGE MOMENTS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
f_emp_m_no_kids = [sum(emp_m_no_kids(:,:,2)); sum(emp_m_no_kids(:,:,3)); sum(emp_m_no_kids(:,:,4)); sum(emp_m_no_kids(:,:,5))]'; % employment total by education
f_emp_m_no_kids = nanmean(f_emp_m_no_kids./count_emp_m_no_kids)
f_emp_m_one_kid = [sum(emp_m_one_kid(:,:,2)); sum(emp_m_one_kid(:,:,3)); sum(emp_m_one_kid(:,:,4)); sum(emp_m_one_kid(:,:,5))]'; % employment total by education
f_emp_m_one_kid = nanmean(f_emp_m_one_kid./count_emp_m_one_kid)
f_emp_m_2_3_kids = [sum(emp_m_2_3_kids(:,:,2)); sum(emp_m_2_3_kids(:,:,3)); sum(emp_m_2_3_kids(:,:,4)); sum(emp_m_2_3_kids(:,:,5))]'; % employment total by education
f_emp_m_2_3_kids = nanmean(f_emp_m_2_3_kids./count_emp_m_2_3_kids)
f_emp_m_4plus_kids = [sum(emp_m_4plus_kids(:,:,2)); sum(emp_m_4plus_kids(:,:,3)); sum(emp_m_4plus_kids(:,:,4)); sum(emp_m_4plus_kids(:,:,5))]'; % employment total by education
f_emp_m_4plus_kids = nanmean(f_emp_m_4plus_kids./count_emp_m_4plus_kids)

f_emp_m_no_y_kids = [sum(emp_m_no_y_kids(:,:,2)); sum(emp_m_no_y_kids(:,:,3)); sum(emp_m_no_y_kids(:,:,4)); sum(emp_m_no_y_kids(:,:,5))]'; % employment total by education
f_emp_m_no_y_kids = f_emp_m_no_y_kids./count_emp_m_no_y_kids;
f_emp_m_one_y_kid = [sum(emp_m_one_y_kid(:,:,2)); sum(emp_m_one_y_kid(:,:,3)); sum(emp_m_one_y_kid(:,:,4)); sum(emp_m_one_y_kid(:,:,5))]'; % employment total by education
f_emp_m_one_y_kid = f_emp_m_one_y_kid./count_emp_m_one_y_kid;
f_emp_m_2_3_y_kids = [sum(emp_m_2_3_y_kids(:,:,2)); sum(emp_m_2_3_y_kids(:,:,3)); sum(emp_m_2_3_y_kids(:,:,4)); sum(emp_m_2_3_y_kids(:,:,5))]'; % employment total by education
f_emp_m_2_3_y_kids = f_emp_m_2_3_y_kids./count_emp_m_2_3_y_kids;
f_emp_m_4plus_y_kids = [sum(emp_m_4plus_y_kids(:,:,2)); sum(emp_m_4plus_y_kids(:,:,3)); sum(emp_m_4plus_y_kids(:,:,4)); sum(emp_m_4plus_y_kids(:,:,5))]'; % employment total by education
f_emp_m_4plus_y_kids = f_emp_m_4plus_y_kids./count_emp_m_4plus_y_kids;

f_emp_m_no_o_kids = [sum(emp_m_no_o_kids(:,:,2)); sum(emp_m_no_o_kids(:,:,3)); sum(emp_m_no_o_kids(:,:,4)); sum(emp_m_no_o_kids(:,:,5))]'; % employment total by education
f_emp_m_no_o_kids = f_emp_m_no_o_kids./count_emp_m_no_o_kids;
f_emp_m_one_o_kid = [sum(emp_m_one_o_kid(:,:,2)); sum(emp_m_one_o_kid(:,:,3)); sum(emp_m_one_o_kid(:,:,4)); sum(emp_m_one_o_kid(:,:,5))]'; % employment total by education
f_emp_m_one_o_kid = f_emp_m_one_o_kid./count_emp_m_one_o_kid;
f_emp_m_2_3_o_kids = [sum(emp_m_2_3_o_kids(:,:,2)); sum(emp_m_2_3_o_kids(:,:,3)); sum(emp_m_2_3_o_kids(:,:,4)); sum(emp_m_2_3_o_kids(:,:,5))]'; % employment total by education
f_emp_m_2_3_o_kids = f_emp_m_2_3_o_kids./count_emp_m_2_3_o_kids;
f_emp_m_4plus_o_kids = [sum(emp_m_4plus_o_kids(:,:,2)); sum(emp_m_4plus_o_kids(:,:,3)); sum(emp_m_4plus_o_kids(:,:,4)); sum(emp_m_4plus_o_kids(:,:,5))]'; % employment total by education
f_emp_m_4plus_o_kids = f_emp_m_4plus_o_kids./count_emp_m_4plus_o_kids;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                   UNMARRIED WOMEN EMPLOYMENT BY KIDS INDIVIDUAL MOMENTS                       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
f_emp_um_no_kids= [sum(emp_um_no_kids(:,:,2)); sum(emp_um_no_kids(:,:,3)); sum(emp_um_no_kids(:,:,4)); sum(emp_um_no_kids(:,:,5))]';    % employment unmarried and no children
f_emp_um_no_kids = nanmean(f_emp_um_no_kids./count_emp_um_no_kids)
f_emp_um_kids= [sum(emp_um_kids(:,:,2)); sum(emp_um_kids(:,:,3)); sum(emp_um_kids(:,:,4)); sum(emp_um_kids(:,:,5))]';   % employment unmarried and no children
f_emp_um_kids = nanmean(f_emp_um_kids./count_emp_um_kids)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                 EMPLOYMENT TRANSITION MATRIX                                                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%f_unemp_to_emp_transition = [mean(just_found_job(:, :, 1));    mean(just_found_job(:, :, 2)); mean(just_found_job(:, :, 3)); mean(just_found_job(:, :, 4))];   % for transition matrix - unemployment to employment 
%f_emp_to_unemp_transition = [mean(just_got_fired(:, :, 1));    mean(just_got_fired(:, :, 2)); mean(just_got_fired(:, :, 3)); mean(just_got_fired(:, :, 4))];   % for transition matrix - employment to unemployment
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                   MARRIED WOMEN EMPLOYMENT + WAGES MOMENTS - AVERAGE
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%just_married(draw_f, t, school_group)=1;               % for transition matrix from single to married
%just_divorced(draw_f, t, school_group)=1;          % for transition matrix from married to divorce
%wages_m_w(draw_f, t, school_group)=wage_w;         % married women wages if employed
%wages_um_w(draw_f, t, school_group)=wage_w;        % unmarried women wages if employed

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%           CLOSE MOMENTS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if 0
objective_function = 0

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%    ESTIMATION PROCESS - SGMM
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 12 moments vectors 1968-2007: 
% year emp_f married_f divorced_f child6_0 child6_1 child6_2 child6_3 child618_0 child618_1 child618_2 child618_3 real_wage_f

fitted_moments_m = [f_emp f_marr f_div  f_y_kids  f_o_kids  f_wages f_emp_m f_emp_um];
fitted_moments_m(12) = fitted_moments_m(12)*moment_12_factor;
actual_moments_idx = fitted_moments_idx + 2*ones(size(fitted_moments_idx));
moments = (actual_moments(1:T,actual_moments_idx) - fitted_moments_m(:,fitted_moments_idx)).^2;

if (strcmp(display,'text'))
    if adjust_T_for_year == 0 || wage_idx < 4
        %if length(fitted_moments_idx) == 1
        fitted_moments_out(wage_idx,:,:) = fitted_moments_m;
        actual_moments_out(wage_idx,:,:) = actual_moments(1:T,3:16);
        %fitted_moments_out2(:,wage_idx) = actual_moments(1:T,actual_moments_idx);
        %fitted_moments_out2(:,wage_idx) = fitted_moments_m(:,fitted_moments_idx(1));
        %else 
        %   fitted_moments_out1(:,wage_idx) = fitted_moments_m(:,fitted_moments_idx(1));
        %   fitted_moments_out2(:,wage_idx) = fitted_moments_m(:,fitted_moments_idx(2));
        %end
    else
        %if length(fitted_moments_idx) == 1
        fitted_moments_out(wage_idx,2:end,:) = fitted_moments_m;
        actual_moments_out(wage_idx,2:end,:) = actual_moments(1:T,3:16);
            %fitted_moments_out1(2:end,wage_idx) = fitted_moments_m(:,fitted_moments_idx(1));
            %fitted_moments_out1(1,wage_idx) = 0;
        %else 
            %fitted_moments_out1(2:end,wage_idx) = fitted_moments_m(:,fitted_moments_idx(1));
            %fitted_moments_out1(1,wage_idx) = 0;
            %fitted_moments_out2(2:end,wage_idx) = fitted_moments_m(:,fitted_moments_idx(2));
            %fitted_moments_out2(1,wage_idx) = 0;
        %end
    end
end

if (strcmp(display,'text'))
    small_std = find(std(moments) < 0.001);
    if (length(small_std) > 0)
        disp('there are moments with std smaller than 0.001');
    end
end

moment_weight=1./(std(moments)+0.0001);   
objective_function=sum(sum(moments).*moment_weight);
% save interim data to file

tmp = [fitted_moments_m(:,fitted_moments_idx) actual_moments(1:T,actual_moments_idx)];

if (strcmp(display,'graph'))
    for graph_idx = 1:length(fitted_moments_idx)
        figure;
        plot(fitted_moments_m(:,fitted_moments_idx(graph_idx)),'b.-');hold on;
        title(sprintf('%s params', f_type));
        xlabel('period');
        ylabel('moments');
        plot(actual_moments(1:T,actual_moments_idx(graph_idx)),'r.-');hold off;
        legend('fitted','actual');
        grid on;
    end
end
end %  if 0
end
